import { memoizeFunction } from '@uifabric-vue/utilities';
import { getGlobalClassNames } from '@uifabric/styling';
import '../node_modules/core-js/modules/es.symbol.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { mergeStyleSets } from '@uifabric/merge-styles';
import '../node_modules/core-js/modules/es.symbol.description.js';

var ButtonGlobalClassNames = {
  msButton: 'ms-Button',
  msButtonHasMenu: 'ms-Button--hasMenu',
  msButtonIcon: 'ms-Button-icon',
  msButtonMenuIcon: 'ms-Button-menuIcon',
  msButtonLabel: 'ms-Button-label',
  msButtonDescription: 'ms-Button-description',
  msButtonScreenReaderText: 'ms-Button-screenReaderText',
  msButtonFlexContainer: 'ms-Button-flexContainer',
  msButtonTextContainer: 'ms-Button-textContainer'
};
var getBaseButtonClassNames = memoizeFunction(function (theme, styles, className, variantClassName, iconClassName, menuIconClassName, disabled, hasMenu, checked, expanded, isSplit) {
  var _selectors, _selectors2;

  var classNames = getGlobalClassNames(ButtonGlobalClassNames, theme || {});
  var isExpanded = expanded && !isSplit;
  return mergeStyleSets({
    root: [classNames.msButton, styles.root, variantClassName, checked && ['is-checked', styles.rootChecked], isExpanded && ['is-expanded', styles.rootExpanded, {
      selectors: (_selectors = {}, _defineProperty(_selectors, ":hover .".concat(classNames.msButtonIcon), styles.iconExpandedHovered), _defineProperty(_selectors, ":hover .".concat(classNames.msButtonMenuIcon), styles.menuIconExpandedHovered || styles.rootExpandedHovered), _defineProperty(_selectors, ':hover', styles.rootExpandedHovered), _selectors)
    }], hasMenu && [ButtonGlobalClassNames.msButtonHasMenu, styles.rootHasMenu], disabled && ['is-disabled', styles.rootDisabled], !disabled && !isExpanded && !checked && {
      selectors: (_selectors2 = {
        ':hover': styles.rootHovered
      }, _defineProperty(_selectors2, ":hover .".concat(classNames.msButtonLabel), styles.labelHovered), _defineProperty(_selectors2, ":hover .".concat(classNames.msButtonIcon), styles.iconHovered), _defineProperty(_selectors2, ":hover .".concat(classNames.msButtonDescription), styles.descriptionHovered), _defineProperty(_selectors2, ":hover .".concat(classNames.msButtonMenuIcon), styles.menuIconHovered), _defineProperty(_selectors2, ':focus', styles.rootFocused), _defineProperty(_selectors2, ':active', styles.rootPressed), _defineProperty(_selectors2, ":active .".concat(classNames.msButtonIcon), styles.iconPressed), _defineProperty(_selectors2, ":active .".concat(classNames.msButtonDescription), styles.descriptionPressed), _defineProperty(_selectors2, ":active .".concat(classNames.msButtonMenuIcon), styles.menuIconPressed), _selectors2)
    }, disabled && checked && [styles.rootCheckedDisabled], !disabled && checked && {
      selectors: {
        ':hover': styles.rootCheckedHovered,
        ':active': styles.rootCheckedPressed
      }
    }, className],
    flexContainer: [classNames.msButtonFlexContainer, styles.flexContainer],
    textContainer: [classNames.msButtonTextContainer, styles.textContainer],
    icon: [classNames.msButtonIcon, iconClassName, styles.icon, isExpanded && styles.iconExpanded, checked && styles.iconChecked, disabled && styles.iconDisabled],
    label: [classNames.msButtonLabel, styles.label, checked && styles.labelChecked, disabled && styles.labelDisabled],
    menuIcon: [classNames.msButtonMenuIcon, menuIconClassName, styles.menuIcon, checked && styles.menuIconChecked, disabled && !isSplit && styles.menuIconDisabled, !disabled && !isExpanded && !checked && {
      selectors: {
        ':hover': styles.menuIconHovered,
        ':active': styles.menuIconPressed
      }
    }, isExpanded && ['is-expanded', styles.menuIconExpanded]],
    description: [classNames.msButtonDescription, styles.description, checked && styles.descriptionChecked, disabled && styles.descriptionDisabled],
    screenReaderText: [classNames.msButtonScreenReaderText, styles.screenReaderText]
  });
});

export { ButtonGlobalClassNames, getBaseButtonClassNames };
