import { memoizeFunction } from '@uifabric-vue/utilities';
import { getFocusStyle } from '@uifabric/styling';
import { concatStyleSets } from '@uifabric/merge-styles';
import { getStyles as getStyles$1 } from '../BaseButton.styles.js';

var getStyles = memoizeFunction(function (theme, customStyles, focusInset, focusColor) {
  var baseButtonStyles = getStyles$1(theme);
  var messageBarButtonStyles = {
    root: [getFocusStyle(theme, {
      inset: 1,
      highContrastStyle: {
        outlineOffset: '-4px',
        outlineColor: 'ActiveBorder'
      },
      borderColor: 'transparent'
    }), {
      height: 24,
      borderColor: theme.palette.neutralTertiaryAlt
    }]
  };
  return concatStyleSets(baseButtonStyles, messageBarButtonStyles, customStyles);
});

export { getStyles };
