import { memoizeFunction } from '@uifabric-vue/utilities';
import { getFocusStyle, HighContrastSelector } from '@uifabric/styling';
import '../../node_modules/core-js/modules/es.symbol.js';
import '../../node_modules/core-js/modules/es.array.filter.js';
import '../../node_modules/core-js/modules/es.array.for-each.js';
import '../../node_modules/core-js/modules/es.object.define-properties.js';
import '../../node_modules/core-js/modules/es.object.define-property.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../../node_modules/core-js/modules/es.object.keys.js';
import '../../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { concatStyleSets } from '@uifabric/merge-styles';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var getStyles = memoizeFunction(function (theme, customStyles) {
  var effects = theme.effects,
      palette = theme.palette;
  var buttonHighContrastFocus = {
    left: -2,
    top: -2,
    bottom: -2,
    right: -2,
    border: 'none'
  };
  var splitButtonDividerBaseStyles = {
    position: 'absolute',
    width: 1,
    right: 31,
    top: 8,
    bottom: 8
  };
  var splitButtonStyles = {
    splitButtonContainer: [getFocusStyle(theme, {
      highContrastStyle: buttonHighContrastFocus,
      inset: 2
    }), {
      display: 'inline-flex',
      selectors: {
        '.ms-Button--default': {
          borderTopRightRadius: '0',
          borderBottomRightRadius: '0',
          borderRight: 'none'
        },
        '.ms-Button--primary': {
          borderTopRightRadius: '0',
          borderBottomRightRadius: '0',
          border: 'none',
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'Window',
            backgroundColor: 'WindowText',
            MsHighContrastAdjust: 'none'
          })
        },
        '.ms-Button--primary + .ms-Button': {
          border: 'none'
        }
      }
    }],
    splitButtonContainerHovered: {
      selectors: {
        '.ms-Button--primary': {
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'Window',
            backgroundColor: 'Highlight'
          })
        },
        '.ms-Button.is-disabled': {
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'GrayText',
            borderColor: 'GrayText',
            backgroundColor: 'Window'
          })
        }
      }
    },
    splitButtonContainerChecked: {
      selectors: {
        '.ms-Button--primary': {
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'Window',
            backgroundColor: 'WindowText',
            MsHighContrastAdjust: 'none'
          })
        }
      }
    },
    splitButtonContainerCheckedHovered: {
      selectors: {
        '.ms-Button--primary': {
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'Window',
            backgroundColor: 'WindowText',
            MsHighContrastAdjust: 'none'
          })
        }
      }
    },
    splitButtonContainerFocused: {
      outline: 'none!important'
    },
    splitButtonMenuButton: {
      padding: 6,
      height: 'auto',
      boxSizing: 'border-box',
      borderRadius: 0,
      borderTopRightRadius: effects.roundedCorner2,
      borderBottomRightRadius: effects.roundedCorner2,
      border: "1px solid ".concat(palette.neutralSecondaryAlt),
      borderLeft: 'none',
      outline: 'transparent',
      userSelect: 'none',
      display: 'inline-block',
      textDecoration: 'none',
      textAlign: 'center',
      cursor: 'pointer',
      verticalAlign: 'top',
      width: 32,
      marginLeft: -1,
      marginTop: 0,
      marginRight: 0,
      marginBottom: 0
    },
    splitButtonDivider: _objectSpread(_objectSpread({}, splitButtonDividerBaseStyles), {}, {
      selectors: _defineProperty({}, HighContrastSelector, {
        backgroundColor: 'WindowText'
      })
    }),
    splitButtonDividerDisabled: _objectSpread(_objectSpread({}, splitButtonDividerBaseStyles), {}, {
      selectors: _defineProperty({}, HighContrastSelector, {
        backgroundColor: 'GrayText'
      })
    }),
    splitButtonMenuButtonDisabled: {
      pointerEvents: 'none',
      border: 'none',
      selectors: _defineProperty({
        ':hover': {
          cursor: 'default'
        },
        '.ms-Button--primary': {
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'GrayText',
            borderColor: 'GrayText',
            backgroundColor: 'Window'
          })
        }
      }, HighContrastSelector, {
        border: '1px solid GrayText',
        color: 'GrayText',
        backgroundColor: 'Window'
      })
    },
    splitButtonFlexContainer: {
      display: 'flex',
      height: '100%',
      flexWrap: 'nowrap',
      justifyContent: 'center',
      alignItems: 'center'
    },
    splitButtonContainerDisabled: {
      outline: 'none',
      border: 'none',
      selectors: _defineProperty({}, HighContrastSelector, {
        color: 'GrayText',
        borderColor: 'GrayText',
        backgroundColor: 'Window'
      })
    }
  };
  return concatStyleSets(splitButtonStyles, customStyles);
});

export { getStyles };
