import '../node_modules/core-js/modules/es.array.concat.js';
import { IsFocusVisibleClassName } from '@uifabric-vue/utilities';
import { getGlobalClassNames, HighContrastSelector } from '@uifabric/styling';
import _defineProperty from '@babel/runtime/helpers/defineProperty';

var GlobalClassNames = {
  root: 'ms-Checkbox',
  label: 'ms-Checkbox-label',
  checkbox: 'ms-Checkbox-checkbox',
  checkmark: 'ms-Checkbox-checkmark',
  text: 'ms-Checkbox-text'
};
var MS_CHECKBOX_LABEL_SIZE = '20px';
var MS_CHECKBOX_TRANSITION_DURATION = '200ms';
var MS_CHECKBOX_TRANSITION_TIMING = 'cubic-bezier(.4, 0, .23, 1)';
var getStyles = function getStyles(props) {
  var _selectors3, _selectors4, _selectors5, _selectors6, _selectors7;

  var className = props.className,
      theme = props.theme,
      reversed = props.reversed,
      checked = props.checked,
      disabled = props.disabled,
      isUsingCustomLabelRender = props.isUsingCustomLabelRender,
      indeterminate = props.indeterminate;
  var semanticColors = theme.semanticColors,
      effects = theme.effects,
      palette = theme.palette,
      fonts = theme.fonts;
  var classNames = getGlobalClassNames(GlobalClassNames, theme);
  var checkmarkFontColor = semanticColors.inputForegroundChecked;
  var checkmarkFontColorHovered = palette.neutralSecondary;
  var checkboxBorderColor = palette.neutralPrimary;
  var checkboxBorderIndeterminateColor = semanticColors.inputBackgroundChecked;
  var checkboxBorderColorChecked = semanticColors.inputBackgroundChecked;
  var checkboxBorderColorDisabled = semanticColors.disabledBodySubtext;
  var checkboxBorderHoveredColor = semanticColors.inputBorderHovered;
  var checkboxBorderIndeterminateHoveredColor = semanticColors.inputBackgroundCheckedHovered;
  var checkboxBackgroundChecked = semanticColors.inputBackgroundChecked;
  var checkboxBackgroundCheckedHovered = semanticColors.inputBackgroundCheckedHovered;
  var checkboxBorderColorCheckedHovered = semanticColors.inputBackgroundCheckedHovered;
  var checkboxHoveredTextColor = semanticColors.inputTextHovered;
  var checkboxBackgroundDisabledChecked = semanticColors.disabledBodySubtext;
  var checkboxTextColor = semanticColors.bodyText;
  var checkboxTextColorDisabled = semanticColors.disabledText;
  var indeterminateDotStyles = [{
    content: '""',
    borderRadius: effects.roundedCorner2,
    position: 'absolute',
    width: 10,
    height: 10,
    top: 4,
    left: 4,
    boxSizing: 'border-box',
    borderWidth: 5,
    borderStyle: 'solid',
    borderColor: disabled ? checkboxBorderColorDisabled : checkboxBorderIndeterminateColor,
    transitionProperty: 'border-width, border, border-color',
    transitionDuration: MS_CHECKBOX_TRANSITION_DURATION,
    transitionTimingFunction: MS_CHECKBOX_TRANSITION_TIMING
  }];
  return {
    root: [classNames.root, {
      position: 'relative',
      display: 'flex'
    }, reversed && 'reversed', checked && 'is-checked', !disabled && 'is-enabled', disabled && 'is-disabled', !disabled && [!checked && {
      selectors: (_selectors3 = {}, _defineProperty(_selectors3, ":hover .".concat(classNames.checkbox), {
        borderColor: checkboxBorderHoveredColor,
        selectors: _defineProperty({}, HighContrastSelector, {
          borderColor: 'Highlight'
        })
      }), _defineProperty(_selectors3, ":focus .".concat(classNames.checkbox), {
        borderColor: checkboxBorderHoveredColor
      }), _defineProperty(_selectors3, ":hover .".concat(classNames.checkmark), {
        color: checkmarkFontColorHovered,
        opacity: '1',
        selectors: _defineProperty({}, HighContrastSelector, {
          color: 'Highlight'
        })
      }), _selectors3)
    }, checked && !indeterminate && {
      selectors: (_selectors5 = {}, _defineProperty(_selectors5, ":hover .".concat(classNames.checkbox), {
        background: checkboxBackgroundCheckedHovered,
        borderColor: checkboxBorderColorCheckedHovered
      }), _defineProperty(_selectors5, ":focus .".concat(classNames.checkbox), {
        background: checkboxBackgroundCheckedHovered,
        borderColor: checkboxBorderColorCheckedHovered
      }), _defineProperty(_selectors5, ".".concat(classNames.checkbox), {
        background: checkboxBorderColorChecked,
        borderColor: checkboxBorderColorChecked
      }), _defineProperty(_selectors5, HighContrastSelector, {
        selectors: (_selectors4 = {}, _defineProperty(_selectors4, ":hover .".concat(classNames.checkbox), {
          background: 'Window',
          borderColor: 'Highlight'
        }), _defineProperty(_selectors4, ":focus .".concat(classNames.checkbox), {
          background: 'Highlight'
        }), _defineProperty(_selectors4, ":focus:hover .".concat(classNames.checkbox), {
          background: 'Highlight'
        }), _defineProperty(_selectors4, ":focus:hover .".concat(classNames.checkmark), {
          color: 'Window'
        }), _defineProperty(_selectors4, ":hover .".concat(classNames.checkmark), {
          color: 'Highlight'
        }), _selectors4)
      }), _selectors5)
    }, indeterminate && {
      selectors: (_selectors6 = {}, _defineProperty(_selectors6, ":hover .".concat(classNames.checkbox, ", :hover .").concat(classNames.checkbox, ":after"), {
        borderColor: checkboxBorderIndeterminateHoveredColor
      }), _defineProperty(_selectors6, ":focus .".concat(classNames.checkbox), {
        borderColor: checkboxBorderIndeterminateHoveredColor
      }), _defineProperty(_selectors6, ":hover .".concat(classNames.checkmark), {
        opacity: '0'
      }), _selectors6)
    }, {
      selectors: (_selectors7 = {}, _defineProperty(_selectors7, ":hover .".concat(classNames.text), {
        color: checkboxHoveredTextColor
      }), _defineProperty(_selectors7, ":focus .".concat(classNames.text), {
        color: checkboxHoveredTextColor
      }), _selectors7)
    }], className],
    input: {
      position: 'absolute',
      background: 'none',
      opacity: 0,
      selectors: _defineProperty({}, ".".concat(IsFocusVisibleClassName, " &:focus + label::before"), {
        outline: '1px solid ' + theme.palette.neutralSecondary,
        outlineOffset: '2px',
        selectors: _defineProperty({}, HighContrastSelector, {
          outline: '1px solid ActiveBorder'
        })
      })
    },
    label: [classNames.label, theme.fonts.medium, {
      display: 'flex',
      alignItems: isUsingCustomLabelRender ? 'center' : 'flex-start',
      cursor: disabled ? 'default' : 'pointer',
      position: 'relative',
      userSelect: 'none',
      textAlign: 'left'
    }, reversed && {
      flexDirection: 'row-reverse',
      justifyContent: 'flex-end'
    }, {
      selectors: {
        '&::before': {
          position: 'absolute',
          left: 0,
          right: 0,
          top: 0,
          bottom: 0,
          content: '""',
          pointerEvents: 'none'
        }
      }
    }],
    checkbox: [classNames.checkbox, {
      position: 'relative',
      display: 'flex',
      flexShrink: 0,
      alignItems: 'center',
      justifyContent: 'center',
      height: MS_CHECKBOX_LABEL_SIZE,
      width: MS_CHECKBOX_LABEL_SIZE,
      border: "1px solid ".concat(checkboxBorderColor),
      borderRadius: effects.roundedCorner2,
      boxSizing: 'border-box',
      transitionProperty: 'background, border, border-color',
      transitionDuration: MS_CHECKBOX_TRANSITION_DURATION,
      transitionTimingFunction: MS_CHECKBOX_TRANSITION_TIMING,
      overflow: 'hidden',
      selectors: {
        ':after': indeterminate ? indeterminateDotStyles : null
      }
    }, indeterminate && {
      borderColor: checkboxBorderIndeterminateColor
    }, !reversed ? {
      marginRight: 4
    } : {
      marginLeft: 4
    }, !disabled && !indeterminate && checked && {
      background: checkboxBackgroundChecked,
      borderColor: checkboxBorderColorChecked,
      selectors: _defineProperty({}, HighContrastSelector, {
        background: 'Highlight',
        borderColor: 'Highlight'
      })
    }, disabled && {
      borderColor: checkboxBorderColorDisabled,
      selectors: _defineProperty({}, HighContrastSelector, {
        borderColor: 'InactiveBorder'
      })
    }, checked && disabled && {
      background: checkboxBackgroundDisabledChecked,
      borderColor: checkboxBorderColorDisabled
    }],
    checkmark: [classNames.checkmark, {
      opacity: checked ? '1' : '0',
      color: checkmarkFontColor,
      selectors: _defineProperty({}, HighContrastSelector, {
        color: disabled ? 'InactiveBorder' : 'Window',
        MsHighContrastAdjust: 'none'
      })
    }],
    text: [classNames.text, {
      color: disabled ? checkboxTextColorDisabled : checkboxTextColor,
      fontSize: fonts.medium.fontSize,
      lineHeight: '20px'
    }, !reversed ? {
      marginLeft: 4
    } : {
      marginRight: 4
    }, disabled && {
      selectors: _defineProperty({}, HighContrastSelector, {
        color: 'InactiveBorder'
      })
    }]
  };
};

export { getStyles };
