import VNodes from '../VNodes.js';
import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { css } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import { Autofill } from '../Autofill/Autofill.js';
import { Callout } from '../Callout/Callout.js';
import '../Button/BaseButton.js';
import { ActionButton } from '../Button/ActionButton/ActionButton.js';
import '../Button/DefaultButton/DefaultButton.js';
import '../Button/PrimaryButton/PrimaryButton.js';
import '../Button/CommandBarButton/CommandBarButton.js';
import '../Button/CompoundButton/CompoundButton.js';
import { IconButton } from '../Button/IconButton/IconButton.js';
import '../Button/MessageBarButton/MessageBarButton.js';
import { ResizeObserver } from 'resize-observer';
import { getStyles } from './ComboBox.styles.js';
import { Label } from '../Label/index.js';
import { getClassNames } from './ComboBox.classNames.js';
import { Checkbox } from '../Checkbox/index.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var SearchDirection;

(function (SearchDirection) {
  SearchDirection[SearchDirection["backward"] = -1] = "backward";
  SearchDirection[SearchDirection["none"] = 0] = "none";
  SearchDirection[SearchDirection["forward"] = 1] = "forward";
})(SearchDirection || (SearchDirection = {}));

var HoverStatus;

(function (HoverStatus) {
  HoverStatus[HoverStatus["clearAll"] = -2] = "clearAll";
  HoverStatus[HoverStatus["default"] = -1] = "default";
})(HoverStatus || (HoverStatus = {}));

var ComboBoxBase = function (_BaseComponent) {
  _inherits(ComboBoxBase, _BaseComponent);

  var _super = _createSuper(ComboBoxBase);

  function ComboBoxBase() {
    var _this;

    _classCallCheck(this, ComboBoxBase);

    _this = _super.apply(this, arguments);
    _this.state = {
      isOpen: false,
      selectedIndices: [],
      focused: false,
      suggestedDisplayValue: '',
      currentOptions: [],
      currentPendingValueValidIndex: 0,
      currentPendingValueValidIndexOnHover: 0,
      currentPendingValue: ''
    };
    _this.comboBoxMenuWidth = 0;
    return _this;
  }

  _createClass(ComboBoxBase, [{
    key: "mounted",
    value: function mounted() {
      var _this2 = this;

      var cb = this._async.throttle(function () {
        if (!_this2.$refs.comboBoxWrapper) return;
        _this2.comboBoxMenuWidth = _this2.$refs.comboBoxWrapper.clientWidth + 2;
      }, 1 / 60);

      var observer = new ResizeObserver(cb);
      observer.observe(this.$refs.comboBoxWrapper);
    }
  }, {
    key: "test",
    value: function test() {
      var h = this.$createElement;
      return h("div", ["Test ", this.comboBoxMenuWidth]);
    }
  }, {
    key: "getComboBoxMenuWidth",
    value: function getComboBoxMenuWidth() {
      if (!this.$refs.comboBoxWrapper) return 0;
      return this.$refs.comboBoxWrapper.clientWidth + 2;
    }
  }, {
    key: "onFocus",
    value: function onFocus(e) {}
  }, {
    key: "onBlur",
    value: function onBlur(e) {
      console.log(e);
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          onFocus = this.onFocus,
          onBlur = this.onBlur,
          calloutProps = this.calloutProps,
          persistMenu = this.persistMenu,
          state = this.state,
          multiSelect = this.multiSelect;
      return h("div", {
        "class": classNames.container
      }, [h(Label, {
        "attrs": {
          "for": "ComboBox".concat(this.uid)
        },
        "class": classNames.label
      }, ["Label"]), h("div", {
        "ref": "comboBoxWrapper",
        "class": classNames.root
      }, [h(Autofill, {
        "attrs": {
          "id": "ComboBox".concat(this.uid),
          "type": "text",
          "role": "combobox"
        },
        "ref": "autofill",
        "class": classNames.input
      }), h(IconButton, {
        "class": "ms-ComboBox-CaretDown-button",
        "attrs": {
          "icon-props": {
            iconName: 'ChevronDown'
          }
        },
        "nativeOn": {
          "focus": onFocus,
          "blur": onBlur
        }
      })]), this.test(), (persistMenu || state.isOpen) && h("div", [h(Callout, {
        "class": css(classNames.callout, calloutProps ? calloutProps.className : undefined),
        "attrs": {
          "target": this.$refs.comboBoxWrapper,
          "is-beak-visible": false,
          "gap-space": 0,
          "do-not-layer": false,
          "callout-width": this.getComboBoxMenuWidth(),
          "callout-max-width": this.getComboBoxMenuWidth(),
          "hidden": persistMenu ? !state.isOpen : undefined
        }
      }, [h("div", {
        "ref": "comboBoxMenu",
        "class": classNames.optionsContainerWrapper
      }, [h("div", {
        "class": classNames.optionsContainer,
        "attrs": {
          "role": "listbox"
        }
      }, [multiSelect && h(Checkbox, {
        "class": "ms-ComboBox-option"
      }), h(ActionButton, {
        "class": "ms-ComboBox-option"
      })])])])])]);
    }
  }, {
    key: "hasErrorMessage",
    get: function get() {
      var errorMessage = this.errorMessage;
      return !!(errorMessage && errorMessage.length > 0);
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          customStyles = this.styles,
          disabled = this.disabled,
          required = this.required,
          allowFreeform = this.allowFreeform,
          hasErrorMessage = this.hasErrorMessage;
      var _this$state = this.state,
          isOpen = _this$state.isOpen,
          focused = _this$state.focused,
          suggestedDisplayValue = _this$state.suggestedDisplayValue;
      return getClassNames(getStyles(theme, customStyles), className, !!isOpen, !!disabled, !!required, !!focused, !!allowFreeform, !!hasErrorMessage);
    }
  }]);

  return ComboBoxBase;
}(BaseComponent);

__decorate([Prop(), __metadata("design:type", Boolean)], ComboBoxBase.prototype, "allowFreeform", void 0);

__decorate([Prop(), __metadata("design:type", String)], ComboBoxBase.prototype, "autoComplete", void 0);

__decorate([Prop(), __metadata("design:type", String)], ComboBoxBase.prototype, "errorMessage", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ComboBoxBase.prototype, "text", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ComboBoxBase.prototype, "calloutProps", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ComboBoxBase.prototype, "buttonIconProps", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ComboBoxBase.prototype, "comboBoxOptionStyles", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ComboBoxBase.prototype, "autofill", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ComboBoxBase.prototype, "disabled", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ComboBoxBase.prototype, "required", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ComboBoxBase.prototype, "persistMenu", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ComboBoxBase.prototype, "multiSelect", void 0);

ComboBoxBase = __decorate([Component({
  components: {
    Autofill: Autofill,
    Label: Label,
    IconButton: IconButton,
    Callout: Callout,
    ActionButton: ActionButton,
    Checkbox: Checkbox,
    VNodes: VNodes
  }
})], ComboBoxBase);

export { ComboBoxBase };
