import '../../node_modules/core-js/modules/es.array.concat.js';
import { IsFocusVisibleClassName } from '@uifabric-vue/utilities';
import { getGlobalClassNames, getFocusStyle, HighContrastSelector, AnimationClassNames, AnimationStyles, FontWeights } from '@uifabric/styling';
import '../../node_modules/core-js/modules/es.symbol.js';
import '../../node_modules/core-js/modules/es.array.filter.js';
import '../../node_modules/core-js/modules/es.array.for-each.js';
import '../../node_modules/core-js/modules/es.object.define-properties.js';
import '../../node_modules/core-js/modules/es.object.define-property.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../../node_modules/core-js/modules/es.object.keys.js';
import '../../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../../node_modules/core-js/modules/es.string.small.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var DetailsRowGlobalClassNames = {
  root: 'ms-DetailsRow',
  compact: 'ms-DetailsList--Compact',
  cell: 'ms-DetailsRow-cell',
  cellAnimation: 'ms-DetailsRow-cellAnimation',
  cellCheck: 'ms-DetailsRow-cellCheck',
  check: 'ms-DetailsRow-check',
  cellMeasurer: 'ms-DetailsRow-cellMeasurer',
  listCellFirstChild: 'ms-List-cell:first-child',
  isContentUnselectable: 'is-contentUnselectable',
  isSelected: 'is-selected',
  isCheckVisible: 'is-check-visible',
  isRowHeader: 'is-row-header',
  fields: 'ms-DetailsRow-fields'
};
var IsFocusableSelector = "[data-is-focusable='true']";
var DEFAULT_CELL_STYLE_PROPS = {
  cellLeftPadding: 12,
  cellRightPadding: 8,
  cellExtraRightPadding: 24
};
var DEFAULT_ROW_HEIGHTS = {
  rowHeight: 42,
  compactRowHeight: 32
};

var values = _objectSpread(_objectSpread({}, DEFAULT_ROW_HEIGHTS), {}, {
  rowVerticalPadding: 11,
  compactRowVerticalPadding: 6
});

var getStyles = function getStyles(props) {
  var _selectors2, _selectors5, _selectors6, _selectors10;

  var theme = props.theme,
      isSelected = props.isSelected,
      canSelect = props.canSelect,
      droppingClassName = props.droppingClassName,
      anySelected = props.anySelected,
      isCheckVisible = props.isCheckVisible,
      checkboxCellClassName = props.checkboxCellClassName,
      compact = props.compact,
      className = props.className,
      _props$cellStyleProps = props.cellStyleProps,
      cellStyleProps = _props$cellStyleProps === void 0 ? DEFAULT_CELL_STYLE_PROPS : _props$cellStyleProps,
      enableUpdateAnimations = props.enableUpdateAnimations;
  var palette = theme.palette,
      fonts = theme.fonts;
  var neutralPrimary = palette.neutralPrimary,
      white = palette.white,
      neutralSecondary = palette.neutralSecondary,
      neutralLighter = palette.neutralLighter,
      neutralLight = palette.neutralLight,
      neutralDark = palette.neutralDark,
      neutralQuaternaryAlt = palette.neutralQuaternaryAlt;
  var focusBorder = theme.semanticColors.focusBorder;
  var classNames = getGlobalClassNames(DetailsRowGlobalClassNames, theme);
  var colors = {
    defaultHeaderText: neutralPrimary,
    defaultMetaText: neutralSecondary,
    defaultBackground: white,
    defaultHoverHeaderText: neutralDark,
    defaultHoverMetaText: neutralPrimary,
    defaultHoverBackground: neutralLighter,
    selectedHeaderText: neutralDark,
    selectedMetaText: neutralPrimary,
    selectedBackground: neutralLight,
    selectedHoverHeaderText: neutralDark,
    selectedHoverMetaText: neutralPrimary,
    selectedHoverBackground: neutralQuaternaryAlt,
    focusHeaderText: neutralDark,
    focusMetaText: neutralPrimary,
    focusBackground: neutralLight,
    focusHoverBackground: neutralQuaternaryAlt
  };
  var selectedStyles = [getFocusStyle(theme, {
    inset: -1,
    borderColor: focusBorder,
    outlineColor: white
  }), classNames.isSelected, {
    color: colors.selectedMetaText,
    background: colors.selectedBackground,
    borderBottom: "1px solid ".concat(white),
    selectors: (_selectors6 = {
      '&:before': {
        position: 'absolute',
        display: 'block',
        top: -1,
        height: 1,
        bottom: 0,
        left: 0,
        right: 0,
        content: '',
        borderTop: "1px solid ".concat(white)
      },
      '&:hover': {
        background: colors.selectedHoverBackground,
        color: colors.selectedHoverMetaText,
        selectors: (_selectors2 = {}, _defineProperty(_selectors2, ".".concat(classNames.cell, " ").concat(HighContrastSelector), {
          color: 'HighlightText',
          selectors: {
            '> a': {
              color: 'HighlightText'
            }
          }
        }), _defineProperty(_selectors2, ".".concat(classNames.isRowHeader), {
          color: colors.selectedHoverHeaderText,
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'HighlightText'
          })
        }), _defineProperty(_selectors2, HighContrastSelector, {
          background: 'Highlight'
        }), _selectors2)
      },
      '&:focus': {
        background: colors.focusBackground,
        selectors: (_selectors5 = {}, _defineProperty(_selectors5, ".".concat(classNames.cell), {
          color: colors.focusMetaText,
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'HighlightText',
            selectors: {
              '> a': {
                color: 'HighlightText'
              }
            }
          })
        }), _defineProperty(_selectors5, ".".concat(classNames.isRowHeader), {
          color: colors.focusHeaderText,
          selectors: _defineProperty({}, HighContrastSelector, {
            color: 'HighlightText'
          })
        }), _defineProperty(_selectors5, HighContrastSelector, {
          background: 'Highlight'
        }), _selectors5)
      }
    }, _defineProperty(_selectors6, HighContrastSelector, {
      background: 'Highlight',
      color: 'HighlightText',
      MsHighContrastAdjust: 'none',
      selectors: {
        a: {
          color: 'HighlightText'
        }
      }
    }), _defineProperty(_selectors6, '&:focus:hover', {
      background: colors.focusHoverBackground
    }), _selectors6)
  }];
  var cannotSelectStyles = [classNames.isContentUnselectable, {
    userSelect: 'none',
    cursor: 'default'
  }];
  var rootCompactStyles = {
    minHeight: values.compactRowHeight,
    border: 0
  };
  var cellCompactStyles = {
    minHeight: values.compactRowHeight,
    paddingTop: values.compactRowVerticalPadding,
    paddingBottom: values.compactRowVerticalPadding,
    paddingLeft: "".concat(cellStyleProps.cellLeftPadding, "px")
  };
  var defaultCellStyles = [getFocusStyle(theme, {
    inset: -1
  }), classNames.cell, {
    display: 'inline-block',
    position: 'relative',
    boxSizing: 'border-box',
    minHeight: values.rowHeight,
    verticalAlign: 'top',
    whiteSpace: 'nowrap',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    paddingTop: values.rowVerticalPadding,
    paddingBottom: values.rowVerticalPadding,
    paddingLeft: "".concat(cellStyleProps.cellLeftPadding, "px"),
    selectors: _defineProperty({
      '& > button': {
        maxWidth: '100%'
      }
    }, IsFocusableSelector, getFocusStyle(theme, {
      inset: -1,
      borderColor: neutralSecondary,
      outlineColor: white
    }))
  }, isSelected && {
    selectors: _defineProperty({}, HighContrastSelector, {
      background: 'Highlight',
      color: 'HighlightText',
      MsHighContrastAdjust: 'none',
      selectors: {
        a: {
          color: 'HighlightText'
        }
      }
    })
  }, compact && cellCompactStyles];
  return {
    root: [classNames.root, AnimationClassNames.fadeIn400, droppingClassName, theme.fonts.small, isCheckVisible && classNames.isCheckVisible, getFocusStyle(theme, {
      borderColor: focusBorder,
      outlineColor: white
    }), {
      borderBottom: "1px solid ".concat(neutralLighter),
      background: colors.defaultBackground,
      color: colors.defaultMetaText,
      display: 'inline-flex',
      minWidth: '100%',
      minHeight: values.rowHeight,
      whiteSpace: 'nowrap',
      padding: 0,
      boxSizing: 'border-box',
      verticalAlign: 'top',
      textAlign: 'left',
      selectors: (_selectors10 = {}, _defineProperty(_selectors10, ".".concat(classNames.listCellFirstChild, " &:before"), {
        display: 'none'
      }), _defineProperty(_selectors10, '&:hover', {
        background: colors.defaultHoverBackground,
        color: colors.defaultHoverMetaText,
        selectors: _defineProperty({}, ".".concat(classNames.isRowHeader), {
          color: colors.defaultHoverHeaderText
        })
      }), _defineProperty(_selectors10, "&:hover .".concat(classNames.check), {
        opacity: 1
      }), _defineProperty(_selectors10, ".".concat(IsFocusVisibleClassName, " &:focus .").concat(classNames.check), {
        opacity: 1
      }), _selectors10)
    }, isSelected && selectedStyles, !canSelect && cannotSelectStyles, compact && rootCompactStyles, className],
    cellUnpadded: {
      paddingRight: "".concat(cellStyleProps.cellRightPadding, "px")
    },
    cellPadded: {
      paddingRight: "".concat(cellStyleProps.cellExtraRightPadding + cellStyleProps.cellRightPadding, "px"),
      selectors: _defineProperty({}, "&.".concat(classNames.cellCheck), {
        paddingRight: 0
      })
    },
    cell: defaultCellStyles,
    cellAnimation: enableUpdateAnimations && AnimationStyles.slideLeftIn40,
    cellMeasurer: [classNames.cellMeasurer, {
      overflow: 'visible',
      whiteSpace: 'nowrap'
    }],
    checkCell: [defaultCellStyles, classNames.cellCheck, checkboxCellClassName, {
      padding: 0,
      paddingTop: 1,
      marginTop: -1,
      flexShrink: 0
    }],
    checkCover: {
      position: 'absolute',
      top: -1,
      left: 0,
      bottom: 0,
      right: 0,
      display: anySelected ? 'block' : 'none'
    },
    fields: [classNames.fields, {
      display: 'flex',
      alignItems: 'stretch'
    }],
    isRowHeader: [classNames.isRowHeader, {
      color: colors.defaultHeaderText,
      fontSize: fonts.medium.fontSize
    }, isSelected && {
      color: colors.selectedHeaderText,
      fontWeight: FontWeights.semibold,
      selectors: _defineProperty({}, HighContrastSelector, {
        color: 'HighlightText'
      })
    }],
    isMultiline: [defaultCellStyles, {
      whiteSpace: 'normal',
      wordBreak: 'break-word',
      textOverflow: 'clip'
    }],
    check: [classNames.check]
  };
};

export { DEFAULT_CELL_STYLE_PROPS, DEFAULT_ROW_HEIGHTS, DetailsRowGlobalClassNames, getStyles };
