import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.number.constructor.js';
import _mergeJSXProps from '../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';
import '../Button/BaseButton.js';
import '../Button/ActionButton/ActionButton.js';
import '../Button/DefaultButton/DefaultButton.js';
import '../Button/PrimaryButton/PrimaryButton.js';
import '../Button/CommandBarButton/CommandBarButton.js';
import '../Button/CompoundButton/CompoundButton.js';
import { IconButton } from '../Button/IconButton/IconButton.js';
import '../Button/MessageBarButton/MessageBarButton.js';
import { DialogType } from './DialogContent.types.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var DialogContentBase = function (_BaseComponent) {
  _inherits(DialogContentBase, _BaseComponent);

  var _super = _createSuper(DialogContentBase);

  function DialogContentBase() {
    _classCallCheck(this, DialogContentBase);

    return _super.apply(this, arguments);
  }

  _createClass(DialogContentBase, [{
    key: "render",
    value: function render() {
      var _this = this;

      var h = arguments[0];
      var classNames = this.classNames,
          css = this.css,
          title = this.title,
          type = this.type,
          showCloseButton = this.showCloseButton,
          closeButtonAriaLabel = this.closeButtonAriaLabel,
          subText = this.subText,
          subTextId = this.subTextId;
      var titleProps = this.titleProps || {};
      var subTextContent;

      if (subText) {
        subTextContent = h("p", {
          "class": classNames.subText,
          "attrs": {
            "id": subTextId
          }
        }, [subText]);
      }

      return h("div", {
        "class": classNames.content
      }, [h("div", {
        "class": classNames.header
      }, [h("div", _mergeJSXProps([{
        "attrs": {
          "id": titleProps.id,
          "role": "heading",
          "aria-level": 1
        }
      }, titleProps, {
        "class": css(classNames.title, titleProps.className)
      }]), [title]), h("div", {
        "class": classNames.topButton
      }, [(type === DialogType.close || showCloseButton && type !== DialogType.largeHeader) && h(IconButton, {
        "class": classNames.button,
        "attrs": {
          "iconProps": {
            iconName: 'Cancel'
          },
          "ariaLabel": closeButtonAriaLabel,
          "title": closeButtonAriaLabel
        },
        "on": {
          "click": function click(ev) {
            return _this.$emit('dismiss', ev);
          }
        }
      })])]), h("div", {
        "class": classNames.inner
      }, [h("div", {
        "class": classNames.innerContent
      }, [subTextContent, this.$slots["default"]]), this.$slots.footer])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          type = this.type,
          draggableHeaderClassName = this.draggableHeaderClassName;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        isLargeHeader: type === DialogType.largeHeader,
        isClose: type === DialogType.close,
        draggableHeaderClassName: draggableHeaderClassName
      });
    }
  }]);

  return DialogContentBase;
}(BaseComponent);

__decorate([Prop({
  type: Number,
  "default": DialogType.normal
}), __metadata("design:type", Number)], DialogContentBase.prototype, "type", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], DialogContentBase.prototype, "draggableHeaderClassName", void 0);

__decorate([Prop({
  type: Object,
  "default": function _default() {}
}), __metadata("design:type", Object)], DialogContentBase.prototype, "titleProps", void 0);

__decorate([Prop({
  type: [String, Object],
  "default": null
}), __metadata("design:type", Object)], DialogContentBase.prototype, "title", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], DialogContentBase.prototype, "showCloseButton", void 0);

__decorate([Prop({
  type: String,
  "default": 'Close'
}), __metadata("design:type", String)], DialogContentBase.prototype, "closeButtonAriaLabel", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], DialogContentBase.prototype, "subText", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], DialogContentBase.prototype, "subTextId", void 0);

DialogContentBase = __decorate([Component], DialogContentBase);

export { DialogContentBase };
