import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.function.name.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.array.map.js';
import { Icon } from '../Icon/index.js';
import '../node_modules/core-js/modules/es.function.bind.js';
import '../Button/BaseButton.js';
import { ActionButton } from '../Button/ActionButton/ActionButton.js';
import '../Button/DefaultButton/DefaultButton.js';
import '../Button/PrimaryButton/PrimaryButton.js';
import '../Button/CommandBarButton/CommandBarButton.js';
import '../Button/CompoundButton/CompoundButton.js';
import '../node_modules/core-js/modules/es.string.link.js';
import '../Button/IconButton/IconButton.js';
import '../Button/MessageBarButton/MessageBarButton.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();
var INDENTATION_SIZE = 14;
var BASE_INDENT = 3;

var Nav = function (_BaseComponent) {
  _inherits(Nav, _BaseComponent);

  var _super = _createSuper(Nav);

  function Nav() {
    var _this;

    _classCallCheck(this, Nav);

    _this = _super.apply(this, arguments);
    _this.isGroupCollapsed = {};
    _this.internalSelectedKey = '';
    return _this;
  }

  _createClass(Nav, [{
    key: "render",
    value: function render(h) {
      var theme = this.theme,
          className = this.className,
          isOnTop = this.isOnTop,
          groups = this.groups;

      if (!groups) {
        return null;
      }

      var groupElements = this.groups.map(this.renderGroup);
      var classNames = getClassNames(this.styles, {
        theme: theme,
        className: className,
        isOnTop: isOnTop,
        groups: groups
      });
      return h("nav", {
        "attrs": {
          "role": "navigation"
        },
        "class": classNames.root
      }, [groupElements]);
    }
  }, {
    key: "renderGroup",
    value: function renderGroup(group, groupIndex) {
      var h = this.$createElement;
      var groups = this.groups,
          theme = this.theme;
      var classNames = getClassNames(this.styles, {
        theme: theme,
        isGroup: true,
        isExpanded: this.isGroupExpanded(group),
        groups: groups
      });
      return h("div", {
        "key": groupIndex
      }, [h("div", {
        "class": classNames.groupContent
      }, [this.renderLinks(group.links, 0)])]);
    }
  }, {
    key: "renderLinks",
    value: function renderLinks(links, nestingLevel) {
      var _this2 = this;

      var h = this.$createElement;
      if (!links || !links.length) return null;
      var linkElements = links.map(function (link, linkIndex) {
        return _this2.renderLink(link, linkIndex, nestingLevel);
      });
      var groups = this.groups,
          theme = this.theme;
      var classNames = getClassNames(this.styles, {
        theme: theme,
        groups: groups
      });
      return h("ul", {
        "attrs": {
          "role": "list"
        },
        "class": classNames.navItems
      }, [linkElements]);
    }
  }, {
    key: "renderLink",
    value: function renderLink(link, linkIndex, nestingLevel) {
      var h = this.$createElement;
      var groups = this.groups,
          theme = this.theme;
      var classNames = getClassNames(this.styles, {
        theme: theme,
        groups: groups
      });
      return h("li", {
        "key": linkIndex,
        "attrs": {
          "role": "listitem"
        },
        "class": classNames.navItem
      }, [this.renderCompositeLink(link, linkIndex, nestingLevel), link.isExpanded ? this.renderLinks(link.links, ++nestingLevel) : null]);
    }
  }, {
    key: "renderCompositeLink",
    value: function renderCompositeLink(link, linkIndex, nestingLevel) {
      var h = this.$createElement;
      var styles = this.styles,
          groups = this.groups,
          theme = this.theme;
      var classNames = getClassNames(this.styles, {
        theme: theme,
        isExpanded: !!link.isExpanded,
        isSelected: false,
        isLink: true,
        isDisabled: link.disabled,
        position: INDENTATION_SIZE * nestingLevel + 1,
        groups: groups
      });
      return h("div", {
        "key": linkIndex,
        "class": classNames.compositeLink
      }, [link.links && link.links.length > 0 ? h("button", {
        "on": {
          "click": this.onLinkExpandClicked.bind(this, link)
        },
        "class": classNames.chevronButton
      }, [h(Icon, {
        "attrs": {
          "class-name": classNames.chevronIcon,
          "icon-name": "ChevronDown"
        },
        "style": link.isExpanded && {
          transform: 'rotate(-180deg)'
        }
      })]) : null, this.renderNavLink(link, linkIndex, nestingLevel)]);
    }
  }, {
    key: "onLinkExpandClicked",
    value: function onLinkExpandClicked(link) {
      link.isExpanded = !link.isExpanded;
    }
  }, {
    key: "renderNavLink",
    value: function renderNavLink(link, linkIndex, nestingLevel) {
      var h = this.$createElement;
      var isSelected = link.key === this.internalSelectedKey;
      var isLinkWithIcon = link.icon || link.iconProps;
      var groups = this.groups,
          theme = this.theme;
      var classNames = getClassNames(this.styles, {
        theme: theme,
        isSelected: isSelected,
        isDisabled: link.disabled,
        isButtonEntry: link.onClick && !link.forceAnchor,
        leftPadding: INDENTATION_SIZE * nestingLevel + BASE_INDENT + (isLinkWithIcon ? 0 : 24),
        groups: groups
      });
      return h(ActionButton, {
        "attrs": {
          "href": link.href || (link.forceAnchor ? '#' : undefined),
          "title": link.title || link.name,
          "target": link.target,
          "disabled": link.disabled
        },
        "nativeOn": {
          "click": this.onNavLinkClicked.bind(this, link, linkIndex)
        },
        "class": [classNames.link, isSelected && classNames.selected],
        "style": {
          paddingLeft: "".concat(INDENTATION_SIZE * nestingLevel + BASE_INDENT + (isLinkWithIcon ? 0 : 24), "px")
        }
      }, [link.name]);
    }
  }, {
    key: "onNavLinkClicked",
    value: function onNavLinkClicked(link, linkIndex) {
      if (link.onClick) link.onClick(link);

      if (!link.url && link.links && link.links.length > 0) {
        link.isExpanded = !link.isExpanded;
      }

      this.internalSelectedKey = link.key;
    }
  }, {
    key: "preventBounce",
    value: function preventBounce(link, ev) {
      if (!link.href && link.forceAnchor) ev.preventDefault();
    }
  }, {
    key: "isGroupExpanded",
    value: function isGroupExpanded(group) {
      if (group.name && this.isGroupCollapsed.hasOwnProperty(group.name)) {
        return !this.isGroupCollapsed[group.name];
      }

      if (group.collapseByDefault !== undefined) {
        return !group.collapseByDefault;
      }

      return true;
    }
  }, {
    key: "toggleCollapsed",
    value: function toggleCollapsed(group) {
      if (group.name) {
        var newGroupCollapsed = _objectSpread(_objectSpread({}, this.isGroupCollapsed), {}, _defineProperty({}, group.name, this.isGroupExpanded(group)));

        this.$set(this, 'isGroupCollapsed', newGroupCollapsed);
      }
    }
  }]);

  return Nav;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  "default": function _default() {
    return [];
  }
}), __metadata("design:type", Array)], Nav.prototype, "groups", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], Nav.prototype, "selectedKey", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], Nav.prototype, "isOnTop", void 0);

Nav = __decorate([Component({
  components: {
    ActionButton: ActionButton,
    Icon: Icon
  }
})], Nav);
var NavBase = Nav;

export default NavBase;
