import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.string.small.js';
import { PersonaSize, PersonaPresence } from './Persona.types.js';

var _sizeToPixels;
var personaSize;

(function (personaSize) {
  personaSize.size8 = '20px';
  personaSize.size10 = '20px';
  personaSize.size16 = '16px';
  personaSize.size24 = '24px';
  personaSize.size28 = '28px';
  personaSize.size32 = '32px';
  personaSize.size40 = '40px';
  personaSize.size48 = '48px';
  personaSize.size56 = '56px';
  personaSize.size72 = '72px';
  personaSize.size100 = '100px';
  personaSize.size120 = '120px';
})(personaSize || (personaSize = {}));

var personaPresenceSize;

(function (personaPresenceSize) {
  personaPresenceSize.size6 = '6px';
  personaPresenceSize.size8 = '8px';
  personaPresenceSize.size12 = '12px';
  personaPresenceSize.size16 = '16px';
  personaPresenceSize.size20 = '20px';
  personaPresenceSize.size28 = '28px';
  personaPresenceSize.size32 = '32px';
  personaPresenceSize.border = '2px';
})(personaPresenceSize || (personaPresenceSize = {}));

var sizeBoolean = function sizeBoolean(size) {
  return {
    isSize8: size === PersonaSize.size8,
    isSize10: size === PersonaSize.size10 || size === PersonaSize.tiny,
    isSize16: size === PersonaSize.size16,
    isSize24: size === PersonaSize.size24 || size === PersonaSize.extraExtraSmall,
    isSize28: size === PersonaSize.size28 || size === PersonaSize.extraSmall,
    isSize32: size === PersonaSize.size32,
    isSize40: size === PersonaSize.size40 || size === PersonaSize.small,
    isSize48: size === PersonaSize.size48 || size === PersonaSize.regular,
    isSize56: size === PersonaSize.size56,
    isSize72: size === PersonaSize.size72 || size === PersonaSize.large,
    isSize100: size === PersonaSize.size100 || size === PersonaSize.extraLarge,
    isSize120: size === PersonaSize.size120
  };
};
var sizeToPixels = (_sizeToPixels = {}, _defineProperty(_sizeToPixels, PersonaSize.tiny, 10), _defineProperty(_sizeToPixels, PersonaSize.extraExtraSmall, 24), _defineProperty(_sizeToPixels, PersonaSize.extraSmall, 28), _defineProperty(_sizeToPixels, PersonaSize.small, 40), _defineProperty(_sizeToPixels, PersonaSize.regular, 48), _defineProperty(_sizeToPixels, PersonaSize.large, 72), _defineProperty(_sizeToPixels, PersonaSize.extraLarge, 100), _defineProperty(_sizeToPixels, PersonaSize.size8, 8), _defineProperty(_sizeToPixels, PersonaSize.size10, 10), _defineProperty(_sizeToPixels, PersonaSize.size16, 16), _defineProperty(_sizeToPixels, PersonaSize.size24, 24), _defineProperty(_sizeToPixels, PersonaSize.size28, 28), _defineProperty(_sizeToPixels, PersonaSize.size32, 32), _defineProperty(_sizeToPixels, PersonaSize.size40, 40), _defineProperty(_sizeToPixels, PersonaSize.size48, 48), _defineProperty(_sizeToPixels, PersonaSize.size56, 56), _defineProperty(_sizeToPixels, PersonaSize.size72, 72), _defineProperty(_sizeToPixels, PersonaSize.size100, 100), _defineProperty(_sizeToPixels, PersonaSize.size120, 120), _sizeToPixels);
var presenceBoolean = function presenceBoolean(presence) {
  return {
    isAvailable: presence === PersonaPresence.online,
    isAway: presence === PersonaPresence.away,
    isBlocked: presence === PersonaPresence.blocked,
    isBusy: presence === PersonaPresence.busy,
    isDoNotDisturb: presence === PersonaPresence.dnd,
    isOffline: presence === PersonaPresence.offline
  };
};

export { personaPresenceSize, personaSize, presenceBoolean, sizeBoolean, sizeToPixels };
