import '../../node_modules/core-js/modules/es.date.to-string.js';
import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../../BaseComponent.js';
import '../../node_modules/core-js/modules/es.number.constructor.js';
import { Icon } from '../../Icon/index.js';
import { PersonaPresence } from '../Persona.types.js';
import { sizeBoolean } from '../PersonaConsts.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var coinSizeFontScaleFactor = 6;
var coinSizePresenceScaleFactor = 3;
var presenceMaxSize = 40;
var presenceFontMaxSize = 20;
var getClassNames = classNamesFunction({
  cacheSize: 100
});

var PersonaPresenceBase = function (_BaseComponent) {
  _inherits(PersonaPresenceBase, _BaseComponent);

  var _super = _createSuper(PersonaPresenceBase);

  function PersonaPresenceBase() {
    var _this;

    _classCallCheck(this, PersonaPresenceBase);

    _this = _super.apply(this, arguments);
    _this.PersonaPresenceEnum = PersonaPresence;
    return _this;
  }

  _createClass(PersonaPresenceBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          presence = this.presence,
          presenceTitle = this.presenceTitle,
          coinSizeWithPresenceStyle = this.coinSizeWithPresenceStyle,
          coinSizeWithPresenceIconStyle = this.coinSizeWithPresenceIconStyle,
          icon = this.icon,
          renderIcon = this.renderIcon;
      if (presence === PersonaPresence.none) return;
      return h("div", {
        "class": classNames.presence,
        "attrs": {
          "title": presenceTitle
        },
        "style": coinSizeWithPresenceStyle
      }, [renderIcon && h(Icon, {
        "class": classNames.presenceIcon,
        "attrs": {
          "icon-name": icon
        },
        "style": coinSizeWithPresenceIconStyle
      })]);
    }
  }, {
    key: "renderIcon",
    get: function get() {
      var coinSize = this.coinSize;
      var size = sizeBoolean(this.size);
      return !(size.isSize8 || size.isSize10 || size.isSize16 || size.isSize24 || size.isSize28 || size.isSize32) && (coinSize ? coinSize > 32 : true);
    }
  }, {
    key: "presenceHeightWidth",
    get: function get() {
      var coinSize = this.coinSize;
      var presenceHeightWidth = coinSize ? coinSize / coinSizePresenceScaleFactor < presenceMaxSize ? coinSize / coinSizePresenceScaleFactor + 'px' : presenceMaxSize + 'px' : '';
      return presenceHeightWidth;
    }
  }, {
    key: "coinSizeWithPresenceStyle",
    get: function get() {
      var coinSize = this.coinSize,
          presenceHeightWidth = this.presenceHeightWidth;
      return coinSize ? {
        width: presenceHeightWidth,
        height: presenceHeightWidth
      } : undefined;
    }
  }, {
    key: "coinSizeWithPresenceIconStyle",
    get: function get() {
      var coinSize = this.coinSize,
          isOutOfOffice = this.isOutOfOffice,
          styles = this.styles,
          presence = this.presence,
          presenceTitle = this.presenceTitle,
          presenceHeightWidth = this.presenceHeightWidth;
      var size = sizeBoolean(this.size);
      var presenceFontSize = coinSize ? coinSize / coinSizeFontScaleFactor < presenceFontMaxSize ? coinSize / coinSizeFontScaleFactor + 'px' : presenceFontMaxSize + 'px' : '';
      return coinSize ? {
        fontSize: presenceFontSize,
        lineHeight: presenceHeightWidth
      } : undefined;
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          presence = this.presence,
          size = this.size,
          isOutOfOffice = this.isOutOfOffice;
      return getClassNames(styles, {
        theme: theme,
        presence: presence,
        size: size,
        isOutOfOffice: isOutOfOffice
      });
    }
  }, {
    key: "icon",
    get: function get() {
      var presence = this.presence,
          isOutOfOffice = this.isOutOfOffice;

      if (!presence) {
        return undefined;
      }

      var oofIcon = 'SkypeArrow';

      switch (PersonaPresence[presence]) {
        case 'online':
          return 'SkypeCheck';

        case 'away':
          return isOutOfOffice ? oofIcon : 'SkypeClock';

        case 'dnd':
          return 'SkypeMinus';

        case 'offline':
          return isOutOfOffice ? oofIcon : '';
      }

      return '';
    }
  }]);

  return PersonaPresenceBase;
}(BaseComponent);

__decorate([Prop({
  type: Number,
  required: true
}), __metadata("design:type", Number)], PersonaPresenceBase.prototype, "presence", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaPresenceBase.prototype, "size", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaPresenceBase.prototype, "isOutOfOffice", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaPresenceBase.prototype, "coinSize", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaPresenceBase.prototype, "presenceTitle", void 0);

PersonaPresenceBase = __decorate([Component({
  components: {
    Icon: Icon
  },
  name: 'PersonaPresence'
})], PersonaPresenceBase);

export { PersonaPresenceBase };
