import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { getDocument, on, getWindow, doesElementContainFocus, KeyCodes } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var Popup = function (_BaseComponent) {
  _inherits(Popup, _BaseComponent);

  var _super = _createSuper(Popup);

  function Popup() {
    var _this;

    _classCallCheck(this, Popup);

    _this = _super.apply(this, arguments);
    _this.needsVerticalScrollBar = false;
    _this._containsFocus = false;
    return _this;
  }

  _createClass(Popup, [{
    key: "created",
    value: function created() {
      this._originalFocusedElement = getDocument().activeElement;
    }
  }, {
    key: "mounted",
    value: function mounted() {
      if (this.$refs.current) {
        this._disposables.push(on(this.$refs.current, 'focus', this._onFocus, true), on(this.$refs.current, 'blur', this._onBlur, true));

        var currentWindow = getWindow(this.$refs.current);

        if (currentWindow) {
          this._disposables.push(on(currentWindow, 'keydown', this._onKeyDown));
        }

        if (doesElementContainFocus(this.$refs.current)) {
          this._containsFocus = true;
        }
      }

      this._updateScrollBarAsync();
    }
  }, {
    key: "updated",
    value: function updated() {
      this._updateScrollBarAsync();

      this._async.dispose();
    }
  }, {
    key: "beforeDestroy",
    value: function beforeDestroy() {
      if (this.shouldRestoreFocus && this._originalFocusedElement && this._containsFocus && this._originalFocusedElement !== window) {
        if (this._originalFocusedElement) {
          this._originalFocusedElement.focus();
        }
      }
    }
  }, {
    key: "render",
    value: function render(h, context) {
      var className = this.className;
      return h("div", {
        "ref": "current",
        "class": className,
        "on": {
          "keydown": this._onKeyDown
        },
        "style": {
          overflowY: this.needsVerticalScrollBar ? 'scroll' : undefined,
          outline: 'none'
        }
      }, [this.$slots["default"]]);
    }
  }, {
    key: "_onKeyDown",
    value: function _onKeyDown(ev) {
      switch (ev.which) {
        case KeyCodes.escape:
          if (this.onDismiss) {
            this.onDismiss(ev);
            ev.preventDefault();
            ev.stopPropagation();
          }

          break;
      }
    }
  }, {
    key: "_updateScrollBarAsync",
    value: function _updateScrollBarAsync() {
      var _this2 = this;

      this._async.requestAnimationFrame(function () {
        _this2._getScrollBar();
      });
    }
  }, {
    key: "_getScrollBar",
    value: function _getScrollBar() {
      if (this.style && this.style.overflowY) {
        return;
      }

      var needsVerticalScrollBar = false;

      if (this.$refs.current && this.$refs.current.firstElementChild) {
        var rootHeight = this.$refs.current.clientHeight;
        var firstChildHeight = this.$refs.current.firstElementChild.clientHeight;

        if (rootHeight > 0 && firstChildHeight > rootHeight) {
          needsVerticalScrollBar = firstChildHeight - rootHeight > 1;
        }
      }

      if (this.needsVerticalScrollBar !== needsVerticalScrollBar) {
        this.needsVerticalScrollBar = needsVerticalScrollBar;
      }
    }
  }, {
    key: "_onFocus",
    value: function _onFocus() {
      this._containsFocus = true;
    }
  }, {
    key: "_onBlur",
    value: function _onBlur(ev) {
      if (this.$refs.current && this.$refs.current.contains(ev.relatedTarget)) {
        this._containsFocus = false;
      }
    }
  }]);

  return Popup;
}(BaseComponent);

__decorate([Prop({
  type: Boolean,
  "default": true
}), __metadata("design:type", Boolean)], Popup.prototype, "shouldRestoreFocus", void 0);

__decorate([Prop({
  type: Function,
  "default": null
}), __metadata("design:type", Function)], Popup.prototype, "onDismiss", void 0);

Popup = __decorate([Component({
  components: {}
})], Popup);

export { Popup };
