import '../node_modules/core-js/modules/es.array.concat.js';
import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.array.map.js';
import '../node_modules/core-js/modules/es.number.constructor.js';
import { Icon } from '../Icon/index.js';
import '../node_modules/core-js/modules/es.regexp.exec.js';
import '../Button/BaseButton.js';
import '../Button/ActionButton/ActionButton.js';
import '../Button/DefaultButton/DefaultButton.js';
import '../Button/PrimaryButton/PrimaryButton.js';
import '../Button/CommandBarButton/CommandBarButton.js';
import '../Button/CompoundButton/CompoundButton.js';
import { IconButton } from '../Button/IconButton/IconButton.js';
import '../Button/MessageBarButton/MessageBarButton.js';
import '../node_modules/core-js/modules/es.string.replace.js';
import '../node_modules/core-js/modules/es.array.fill.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var RatingBase = function (_BaseComponent) {
  _inherits(RatingBase, _BaseComponent);

  var _super = _createSuper(RatingBase);

  function RatingBase() {
    var _this;

    _classCallCheck(this, RatingBase);

    _this = _super.apply(this, arguments);
    _this.internalValue = _this.rating;
    return _this;
  }

  _createClass(RatingBase, [{
    key: "getRatingIconName",
    value: function getRatingIconName(ratingLevel) {
      return this.internalValue >= ratingLevel ? this.iconName : this.unselectedIconName;
    }
  }, {
    key: "getRatingFillPercentage",
    value: function getRatingFillPercentage(ratingLevel) {
      if (ratingLevel - this.internalValue <= 0) return '100%';
      if (ratingLevel - this.internalValue > 1) return '0%';
      if (ratingLevel - this.internalValue > 0) return "".concat((1 - (ratingLevel - this.internalValue)) * 100, "%");
    }
  }, {
    key: "setRating",
    value: function setRating(rating) {
      this.internalValue = rating;
    }
  }, {
    key: "onPropValueChanged",
    value: function onPropValueChanged(newValue) {
      this.internalValue = newValue;
    }
  }, {
    key: "onValueChanged",
    value: function onValueChanged(value) {
      this.$emit('input', value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var classNames = this.classNames,
          readonly = this.readonly,
          max = this.max,
          size = this.size,
          disabled = this.disabled,
          iconName = this.iconName;
      return h("div", {
        "attrs": {
          "area-label": "areaLabel"
        },
        "class": classNames.root,
        "style": {
          '--size': "".concat(size, "px")
        }
      }, [h("div", {
        "class": classNames.ratingFocusZone
      }, [this.ratingLevels.map(function (ratingLevel) {
        return h("button", {
          "key": ratingLevel,
          "attrs": _objectSpread(_objectSpread({}, _this2.$attrs), {}, {
            "disabled": disabled
          }),
          "class": classNames.ratingButton,
          "on": {
            "click": function click() {
              !disabled && !readonly && _this2.setRating(ratingLevel);
            }
          }
        }, [h("span", {
          "class": classNames.labelText
        }, ["Select ".concat(ratingLevel, " of ").concat(max)]), h("div", {
          "class": classNames.ratingStar
        }, [h(Icon, {
          "attrs": {
            "icon-name": _this2.getRatingIconName(ratingLevel)
          },
          "class": classNames.ratingStarBack
        }), h(Icon, {
          "attrs": {
            "icon-name": iconName
          },
          "class": classNames.ratingStarFront,
          "style": {
            width: _this2.getRatingFillPercentage(ratingLevel)
          }
        })])]);
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var disabled = this.disabled,
          readonly = this.readonly,
          theme = this.theme;
      return getClassNames(this.styles, {
        disabled: disabled,
        readOnly: readonly,
        theme: theme
      });
    }
  }, {
    key: "ratingLevels",
    get: function get() {
      var min = this.min,
          max = this.max;
      if (min < 0 || max <= min) return [];
      var i = min + 1;
      return Array(max - min).fill(undefined).map(function () {
        return i++;
      });
    }
  }, {
    key: "areaLabel",
    get: function get() {
      if (!this.ariaLabelFormat) return '';
      return this.ariaLabelFormat.replace('{0}', "".concat(this.internalValue)).replace('{1}', "".concat(this.max));
    }
  }]);

  return RatingBase;
}(BaseComponent);

__decorate([Prop({
  type: Number,
  "default": 16
}), __metadata("design:type", Number)], RatingBase.prototype, "size", void 0);

__decorate([Prop({
  type: Number,
  "default": 0
}), __metadata("design:type", Number)], RatingBase.prototype, "min", void 0);

__decorate([Prop({
  type: Number,
  "default": 10
}), __metadata("design:type", Number)], RatingBase.prototype, "max", void 0);

__decorate([Prop({
  type: Number,
  "default": 0
}), __metadata("design:type", Number)], RatingBase.prototype, "rating", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], RatingBase.prototype, "ariaLabelFormat", void 0);

__decorate([Prop({
  type: String,
  "default": 'FavoriteStarFill'
}), __metadata("design:type", String)], RatingBase.prototype, "iconName", void 0);

__decorate([Prop({
  type: String,
  "default": 'FavoriteStar'
}), __metadata("design:type", String)], RatingBase.prototype, "unselectedIconName", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], RatingBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], RatingBase.prototype, "readonly", void 0);

__decorate([Watch('rating'), __metadata("design:type", Function), __metadata("design:paramtypes", [Number]), __metadata("design:returntype", void 0)], RatingBase.prototype, "onPropValueChanged", null);

__decorate([Watch('internalValue'), __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], RatingBase.prototype, "onValueChanged", null);

RatingBase = __decorate([Component({
  components: {
    Icon: Icon,
    IconButton: IconButton
  },
  inheritAttrs: false
})], RatingBase);

export { RatingBase };
