import { getGlobalClassNames, HighContrastSelector } from '@uifabric/styling';
import _defineProperty from '@babel/runtime/helpers/defineProperty';

var GlobalClassNames = {
  root: 'ms-ScrollablePane',
  contentContainer: 'ms-ScrollablePane--contentContainer'
};
var getStyles = function getStyles(props) {
  var className = props.className,
      theme = props.theme;
  var classNames = getGlobalClassNames(GlobalClassNames, theme);
  var AboveAndBelowStyles = {
    position: 'absolute',
    pointerEvents: 'auto'
  };
  var positioningStyle = {
    position: 'absolute',
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    WebkitOverflowScrolling: 'touch'
  };
  return {
    root: [classNames.root, theme.fonts.medium, positioningStyle, className],
    contentContainer: [classNames.contentContainer, {
      overflowY: props.scrollbarVisibility === 'always' ? 'scroll' : 'auto'
    }, positioningStyle],
    stickyAbove: [{
      top: 0,
      zIndex: 1,
      selectors: _defineProperty({}, HighContrastSelector, {
        borderBottom: '1px solid WindowText'
      })
    }, AboveAndBelowStyles],
    stickyBelow: [{
      bottom: 0,
      selectors: _defineProperty({}, HighContrastSelector, {
        borderTop: '1px solid WindowText'
      })
    }, AboveAndBelowStyles],
    stickyBelowItems: [{
      bottom: 0
    }, AboveAndBelowStyles, {
      width: '100%'
    }]
  };
};

export { getStyles };
