import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction, KeyCodes } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.number.constructor.js';
import '../node_modules/core-js/modules/web.timers.js';
import '../node_modules/core-js/modules/es.number.to-fixed.js';
import { Label } from '../Label/index.js';
import '../node_modules/core-js/modules/es.parse-float.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();
var ONKEYDOWN_TIMEOUT_DURATION = 1000;

var SliderBase = function (_BaseComponent) {
  _inherits(SliderBase, _BaseComponent);

  var _super = _createSuper(SliderBase);

  function SliderBase() {
    var _this;

    _classCallCheck(this, SliderBase);

    _this = _super.apply(this, arguments);
    _this.internalValue = _this.value || _this.defaultValue || _this.min;
    _this.renderedValue = _this.value || _this.defaultValue || _this.min;
    _this.onKeyDownTimer = -1;
    return _this;
  }

  _createClass(SliderBase, [{
    key: "onMouseDown",
    value: function onMouseDown(event) {
      if (this.disabled) return;

      if (event.type === 'mousedown') {
        window.addEventListener('mousemove', this.onMove, true);
        window.addEventListener('mouseup', this.onMouseUp, true);
      } else if (event.type === 'touchstart') {
        window.addEventListener('touchmove', this.onMove, true);
        window.addEventListener('touchend', this.onMouseUp, true);
      }

      this.onMove(event);
    }
  }, {
    key: "onMouseUp",
    value: function onMouseUp(event) {
      if (this.disabled) return;
      this.renderedValue = this.internalValue;
      window.removeEventListener('mousemove', this.onMove, true);
      window.removeEventListener('mouseup', this.onMouseUp, true);
      window.removeEventListener('touchmove', this.onMove, true);
      window.removeEventListener('touchend', this.onMouseUp, true);
    }
  }, {
    key: "onMove",
    value: function onMove(event) {
      var _this2 = this;

      window.requestAnimationFrame(function () {
        var max = _this2.max,
            min = _this2.min,
            step = _this2.step,
            vertical = _this2.vertical;
        var steps = (max - min) / step;

        var sliderPositionRect = _this2.$refs.sliderLine.getBoundingClientRect();

        var sliderLength = !vertical ? sliderPositionRect.width : sliderPositionRect.height;
        var stepLength = sliderLength / steps;
        var currentSteps;
        var distance;

        if (!vertical) {
          var left = _this2.getPosition(event, vertical);

          distance = left - sliderPositionRect.left;
          currentSteps = distance / stepLength;
        } else {
          var bottom = _this2.getPosition(event, vertical);

          distance = sliderPositionRect.bottom - bottom;
          currentSteps = distance / stepLength;
        }

        var internalValue;
        var renderedValue;

        if (currentSteps > Math.floor(steps)) {
          renderedValue = internalValue = max;
        } else if (currentSteps < 0) {
          renderedValue = internalValue = min;
        } else {
          renderedValue = min + step * currentSteps;
          internalValue = min + step * Math.round(currentSteps);
        }

        _this2.updateValue(internalValue, renderedValue);
      });
    }
  }, {
    key: "getPosition",
    value: function getPosition(event, vertical) {
      var currentPosition;

      switch (event.type) {
        case 'mousedown':
        case 'mousemove':
          currentPosition = !vertical ? event.clientX : event.clientY;
          break;

        case 'touchstart':
        case 'touchmove':
          currentPosition = !vertical ? event.touches[0].clientX : event.touches[0].clientY;
          break;
      }

      return currentPosition;
    }
  }, {
    key: "updateValue",
    value: function updateValue(value, renderedValue) {
      var step = this.step,
          snapToStep = this.snapToStep;
      var numDec = 0;

      if (isFinite(step)) {
        while (Math.round(step * Math.pow(10, numDec)) / Math.pow(10, numDec) !== step) {
          numDec++;
        }
      }

      var roundedValue = parseFloat(value.toFixed(numDec));
      var valueChanged = roundedValue !== this.internalValue;

      if (snapToStep) {
        renderedValue = roundedValue;
      }

      this.internalValue = roundedValue;
      this.renderedValue = renderedValue;
      this.$emit('input', roundedValue);
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(event) {
      var value = this.internalValue;
      var max = this.max,
          min = this.min,
          step = this.step;
      var diff = 0;

      switch (event.which) {
        case KeyCodes.left:
        case KeyCodes.down:
          diff = -step;
          this.clearOnKeyDownTimer();
          this.setOnKeyDownTimer(event);
          break;

        case KeyCodes.right:
        case KeyCodes.up:
          diff = step;
          this.clearOnKeyDownTimer();
          this.setOnKeyDownTimer(event);
          break;

        case KeyCodes.home:
          value = min;
          break;

        case KeyCodes.end:
          value = max;
          break;

        default:
          return;
      }

      var newValue = Math.min(max, Math.max(min, value + diff));
      this.updateValue(newValue, newValue);
      event.preventDefault();
      event.stopPropagation();
    }
  }, {
    key: "clearOnKeyDownTimer",
    value: function clearOnKeyDownTimer() {
      clearTimeout(this.onKeyDownTimer);
    }
  }, {
    key: "setOnKeyDownTimer",
    value: function setOnKeyDownTimer(event) {
      this.onKeyDownTimer = setTimeout(function () {}, ONKEYDOWN_TIMEOUT_DURATION);
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          disabled = this.disabled,
          originFromZero = this.originFromZero,
          vertical = this.vertical,
          zeroOffsetPercent = this.zeroOffsetPercent,
          thumbOffsetPercent = this.thumbOffsetPercent,
          lengthString = this.lengthString,
          internalValue = this.internalValue,
          css = this.css,
          label = this.label;
      return h("div", {
        "class": classNames.root
      }, [h(Label, {
        "class": classNames.titleLabel
      }, [label]), h("div", {
        "class": classNames.container
      }, [h("div", {
        "class": classNames.slideBox,
        "attrs": {
          "tabindex": disabled ? void 0 : 0
        },
        "on": {
          "mousedown": this.onMouseDown,
          "keydown": this.onKeyDown
        }
      }, [h("div", {
        "ref": "sliderLine",
        "class": classNames.line
      }, [originFromZero && h("span", {
        "class": classNames.zeroTick,
        "style": _defineProperty({}, vertical ? 'bottom' : 'left', "".concat(zeroOffsetPercent, "%"))
      }), h("span", {
        "class": classNames.thumb,
        "style": _defineProperty({}, vertical ? 'bottom' : 'left', "".concat(thumbOffsetPercent, "%"))
      }), originFromZero && h("span", {
        "class": css(classNames.lineContainer, classNames.inactiveSection),
        "style": _defineProperty({}, lengthString, "".concat(Math.min(thumbOffsetPercent, zeroOffsetPercent), "%"))
      }), originFromZero && h("span", {
        "class": css(classNames.lineContainer, classNames.activeSection),
        "style": _defineProperty({}, lengthString, "".concat(Math.abs(zeroOffsetPercent - thumbOffsetPercent), "%"))
      }), originFromZero && h("span", {
        "class": css(classNames.lineContainer, classNames.inactiveSection),
        "style": _defineProperty({}, lengthString, "".concat(Math.min(100 - thumbOffsetPercent, 100 - zeroOffsetPercent), "%"))
      }), !originFromZero && h("span", {
        "class": css(classNames.lineContainer, classNames.activeSection),
        "style": _defineProperty({}, lengthString, "".concat(thumbOffsetPercent, "%"))
      }), !originFromZero && h("span", {
        "class": css(classNames.lineContainer, classNames.inactiveSection),
        "style": _defineProperty({}, lengthString, "".concat(100 - thumbOffsetPercent, "%"))
      })])]), h(Label, {
        "class": classNames.valueLabel
      }, [this.$scopedSlots.value ? this.$scopedSlots.value({
        value: internalValue
      }) : internalValue])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var className = this.className,
          disabled = this.disabled,
          vertical = this.vertical,
          renderedValue = this.renderedValue,
          internalValue = this.internalValue,
          showValue = this.showValue,
          theme = this.theme;
      return getClassNames(this.styles, {
        className: className,
        disabled: disabled,
        vertical: vertical,
        showTransitions: renderedValue === internalValue,
        showValue: showValue,
        theme: theme
      });
    }
  }, {
    key: "thumbOffsetPercent",
    get: function get() {
      var min = this.min,
          max = this.max,
          renderedValue = this.renderedValue;
      return min === max ? 0 : (renderedValue - min) / (max - min) * 100;
    }
  }, {
    key: "zeroOffsetPercent",
    get: function get() {
      var min = this.min,
          max = this.max;
      return min >= 0 ? 0 : -min / (max - min) * 100;
    }
  }, {
    key: "lengthString",
    get: function get() {
      return this.vertical ? 'height' : 'width';
    }
  }]);

  return SliderBase;
}(BaseComponent);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], SliderBase.prototype, "label", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], SliderBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], SliderBase.prototype, "vertical", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], SliderBase.prototype, "snapToStep", void 0);

__decorate([Prop({
  type: Number,
  "default": 0
}), __metadata("design:type", Number)], SliderBase.prototype, "min", void 0);

__decorate([Prop({
  type: Number,
  "default": 10
}), __metadata("design:type", Number)], SliderBase.prototype, "max", void 0);

__decorate([Prop({
  type: Number,
  "default": 1
}), __metadata("design:type", Number)], SliderBase.prototype, "step", void 0);

__decorate([Prop({
  type: Number,
  "default": null
}), __metadata("design:type", Number)], SliderBase.prototype, "value", void 0);

__decorate([Prop({
  type: Number,
  "default": null
}), __metadata("design:type", Number)], SliderBase.prototype, "defaultValue", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], SliderBase.prototype, "showValue", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], SliderBase.prototype, "originFromZero", void 0);

SliderBase = __decorate([Component({
  components: {
    Label: Label
  }
})], SliderBase);

export { ONKEYDOWN_TIMEOUT_DURATION, SliderBase };
