import '../node_modules/core-js/modules/es.array.concat.js';
import { getGlobalClassNames } from '@uifabric/styling';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { parseGap, parsePadding } from './StackUtils.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var nameMap = {
  start: 'flex-start',
  end: 'flex-end'
};
var GlobalClassNames = {
  root: 'ms-Stack',
  inner: 'ms-Stack-inner'
};
var styles = function styles(props, theme, tokens) {
  var verticalFill = props.verticalFill,
      horizontal = props.horizontal,
      reversed = props.reversed,
      gap = props.gap,
      grow = props.grow,
      wrap = props.wrap,
      horizontalAlign = props.horizontalAlign,
      verticalAlign = props.verticalAlign,
      disableShrink = props.disableShrink,
      className = props.className;
  var classNames = getGlobalClassNames(GlobalClassNames, theme);
  var childrenGap = tokens && tokens.childrenGap ? tokens.childrenGap : gap;
  var maxHeight = tokens && tokens.maxHeight ? tokens.maxHeight : props.maxHeight;
  var maxWidth = tokens && tokens.maxWidth ? tokens.maxWidth : props.maxWidth;
  var padding = tokens && tokens.padding ? tokens.padding : props.padding;

  var _parseGap = parseGap(childrenGap, theme),
      rowGap = _parseGap.rowGap,
      columnGap = _parseGap.columnGap;

  var horizontalMargin = "".concat(-0.5 * columnGap.value).concat(columnGap.unit);
  var verticalMargin = "".concat(-0.5 * rowGap.value).concat(rowGap.unit);
  var childStyles = {
    textOverflow: 'ellipsis'
  };
  var commonSelectors = {
    '> *:not(.ms-StackItem)': {
      flexShrink: disableShrink ? 0 : 1
    }
  };

  if (wrap) {
    return {
      root: [classNames.root, {
        flexWrap: 'wrap',
        maxWidth: maxWidth,
        maxHeight: maxHeight,
        width: 'auto',
        overflow: 'visible',
        height: '100%'
      }, horizontalAlign && _defineProperty({}, horizontal ? 'justifyContent' : 'alignItems', nameMap[horizontalAlign] || horizontalAlign), verticalAlign && _defineProperty({}, horizontal ? 'alignItems' : 'justifyContent', nameMap[verticalAlign] || verticalAlign), className, {
        display: 'flex'
      }, horizontal && {
        height: verticalFill ? '100%' : 'auto'
      }],
      inner: [classNames.inner, {
        display: 'flex',
        flexWrap: 'wrap',
        marginLeft: horizontalMargin,
        marginRight: horizontalMargin,
        marginTop: verticalMargin,
        marginBottom: verticalMargin,
        overflow: 'visible',
        boxSizing: 'border-box',
        padding: parsePadding(padding, theme),
        width: columnGap.value === 0 ? '100%' : "calc(100% + ".concat(columnGap.value).concat(columnGap.unit, ")"),
        maxWidth: '100vw',
        selectors: _objectSpread({
          '> *': _objectSpread({
            margin: "".concat(0.5 * rowGap.value).concat(rowGap.unit, " ").concat(0.5 * columnGap.value).concat(columnGap.unit)
          }, childStyles)
        }, commonSelectors)
      }, horizontalAlign && _defineProperty({}, horizontal ? 'justifyContent' : 'alignItems', nameMap[horizontalAlign] || horizontalAlign), verticalAlign && _defineProperty({}, horizontal ? 'alignItems' : 'justifyContent', nameMap[verticalAlign] || verticalAlign), horizontal && {
        flexDirection: reversed ? 'row-reverse' : 'row',
        height: rowGap.value === 0 ? '100%' : "calc(100% + ".concat(rowGap.value).concat(rowGap.unit, ")"),
        selectors: {
          '> *': {
            maxWidth: columnGap.value === 0 ? '100%' : "calc(100% - ".concat(columnGap.value).concat(columnGap.unit, ")")
          }
        }
      }, !horizontal && {
        flexDirection: reversed ? 'column-reverse' : 'column',
        height: "calc(100% + ".concat(rowGap.value).concat(rowGap.unit, ")"),
        selectors: {
          '> *': {
            maxHeight: rowGap.value === 0 ? '100%' : "calc(100% - ".concat(rowGap.value).concat(rowGap.unit, ")")
          }
        }
      }]
    };
  }

  return {
    root: [classNames.root, {
      display: 'flex',
      flexDirection: horizontal ? reversed ? 'row-reverse' : 'row' : reversed ? 'column-reverse' : 'column',
      flexWrap: 'nowrap',
      width: 'auto',
      height: verticalFill ? '100%' : 'auto',
      maxWidth: maxWidth,
      maxHeight: maxHeight,
      padding: parsePadding(padding, theme),
      boxSizing: 'border-box',
      selectors: _objectSpread(_defineProperty({
        '> *': childStyles
      }, reversed ? '> *:not(:last-child)' : '> *:not(:first-child)', [horizontal && {
        marginLeft: "".concat(columnGap.value).concat(columnGap.unit)
      }, !horizontal && {
        marginTop: "".concat(rowGap.value).concat(rowGap.unit)
      }]), commonSelectors)
    }, grow && {
      flexGrow: grow === true ? 1 : grow
    }, horizontalAlign && _defineProperty({}, horizontal ? 'justifyContent' : 'alignItems', nameMap[horizontalAlign] || horizontalAlign), verticalAlign && _defineProperty({}, horizontal ? 'alignItems' : 'justifyContent', nameMap[verticalAlign] || verticalAlign), className]
  };
};

export { styles };
