import '../../node_modules/core-js/modules/es.array.concat.js';
import '../../node_modules/core-js/modules/es.date.to-string.js';
import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { memoizeFunction, classNamesFunction } from '@uifabric-vue/utilities';
import { mergeStyleSets } from '@uifabric/styling';
import BaseComponent from '../../BaseComponent.js';
import '../../node_modules/core-js/modules/es.symbol.js';
import '../../node_modules/core-js/modules/es.array.filter.js';
import '../../node_modules/core-js/modules/es.array.for-each.js';
import '../../node_modules/core-js/modules/es.array.join.js';
import '../../node_modules/core-js/modules/es.function.name.js';
import '../../node_modules/core-js/modules/es.object.define-properties.js';
import '../../node_modules/core-js/modules/es.object.define-property.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../../node_modules/core-js/modules/es.object.keys.js';
import '../../node_modules/core-js/modules/web.dom-collections.for-each.js';
import '@babel/runtime/helpers/defineProperty';
import '../../node_modules/core-js/modules/es.symbol.description.js';
import '../../node_modules/core-js/modules/es.symbol.iterator.js';
import '../../node_modules/core-js/modules/es.array.from.js';
import '../../node_modules/core-js/modules/es.array.is-array.js';
import '../../node_modules/core-js/modules/es.array.iterator.js';
import '../../node_modules/core-js/modules/es.array.map.js';
import '../../node_modules/core-js/modules/es.array.slice.js';
import '../../node_modules/core-js/modules/es.number.constructor.js';
import '../../node_modules/core-js/modules/es.string.iterator.js';
import '../../node_modules/core-js/modules/web.dom-collections.iterator.js';
import '../../node_modules/core-js/modules/es.array.reduce.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../../../utilities/positioning/positioning.types.js';
import '../../../utilities/positioning/positioning.js';
import '../../node_modules/core-js/modules/es.regexp.exec.js';
import '../../node_modules/core-js/modules/es.string.split.js';
import '../../../utilities/grid/Grid.js';
import { getStyles } from '../../Button/ActionButton/ActionButton.styles.js';
import { GridCell } from '../../../utilities/grid/GridCell.js';
import '../../../utilities/color/shades.js';
import '../../node_modules/core-js/modules/es.parse-int.js';
import '../../node_modules/core-js/modules/es.string.match.js';
import '../../node_modules/core-js/modules/es.string.trim.js';
import { getColorFromString } from '../../../utilities/color/getColorFromString.js';
import '../../../utilities/keytips/IKeytipTransitionKey.js';
import '../../../utilities/keytips/KeytipConstants.js';
import '../../../utilities/keytips/KeytipManager.js';
import '../../node_modules/core-js/modules/es.string.replace.js';
import '../../../utilities/responsiveMode.js';
import '../../../utilities/selectableOption/SelectableOption.types.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getColorPickerGridCellButtonClassNames = memoizeFunction(function (theme, className, variantClassName, iconClassName, menuIconClassName, disabled, checked, expanded, isSplit) {
  var styles = getStyles(theme);
  return mergeStyleSets({
    root: ['ms-Button', styles.root, variantClassName, className, checked && ['is-checked', styles.rootChecked], disabled && ['is-disabled', styles.rootDisabled], !disabled && !checked && {
      selectors: {
        ':hover': styles.rootHovered,
        ':focus': styles.rootFocused,
        ':active': styles.rootPressed
      }
    }, disabled && checked && [styles.rootCheckedDisabled], !disabled && checked && {
      selectors: {
        ':hover': styles.rootCheckedHovered,
        ':active': styles.rootCheckedPressed
      }
    }],
    flexContainer: ['ms-Button-flexContainer', styles.flexContainer]
  });
});
var getClassNames = classNamesFunction();

var ColorPickerGridCellBase = function (_BaseComponent) {
  _inherits(ColorPickerGridCellBase, _BaseComponent);

  var _super = _createSuper(ColorPickerGridCellBase);

  function ColorPickerGridCellBase() {
    _classCallCheck(this, ColorPickerGridCellBase);

    return _super.apply(this, arguments);
  }

  _createClass(ColorPickerGridCellBase, [{
    key: "isWhiteCell",
    value: function isWhiteCell(inputColor) {
      var color = getColorFromString(inputColor);
      return color.hex === 'ffffff';
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          color = this.color,
          circle = this.circle;
      return h(GridCell, {
        "class": classNames.colorCell
      }, [h("svg", {
        "class": classNames.svg,
        "attrs": {
          "viewBox": "0 0 20 20",
          "fill": getColorFromString(color).str
        }
      }, [circle ? h("circle", {
        "attrs": {
          "cx": "50%",
          "cy": "50%",
          "r": "50%"
        }
      }) : h("rect", {
        "attrs": {
          "width": "100%",
          "height": "100%"
        }
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          circle = this.circle,
          color = this.color,
          disabled = this.disabled,
          selected = this.selected,
          height = this.height,
          width = this.width,
          borderWidth = this.borderWidth;
      return getClassNames(styles, {
        theme: theme,
        disabled: disabled,
        selected: selected,
        circle: circle,
        isWhite: this.isWhiteCell(color),
        height: height,
        width: width,
        borderWidth: borderWidth
      });
    }
  }]);

  return ColorPickerGridCellBase;
}(BaseComponent);

__decorate([Prop({
  type: Boolean,
  "default": true
}), __metadata("design:type", Boolean)], ColorPickerGridCellBase.prototype, "circle", void 0);

__decorate([Prop({
  type: String
}), __metadata("design:type", String)], ColorPickerGridCellBase.prototype, "color", void 0);

__decorate([Prop({
  type: Boolean
}), __metadata("design:type", Boolean)], ColorPickerGridCellBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean
}), __metadata("design:type", Boolean)], ColorPickerGridCellBase.prototype, "selected", void 0);

__decorate([Prop({
  type: Number,
  "default": 20
}), __metadata("design:type", Number)], ColorPickerGridCellBase.prototype, "height", void 0);

__decorate([Prop({
  type: Number,
  "default": 20
}), __metadata("design:type", Number)], ColorPickerGridCellBase.prototype, "width", void 0);

__decorate([Prop({
  type: Number,
  "default": 2
}), __metadata("design:type", Number)], ColorPickerGridCellBase.prototype, "borderWidth", void 0);

ColorPickerGridCellBase = __decorate([Component({
  components: {
    GridCell: GridCell
  }
})], ColorPickerGridCellBase);

export { ColorPickerGridCellBase };
