import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Model, Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import { Label } from '../Label/index.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ToggleBase = function (_BaseComponent) {
  _inherits(ToggleBase, _BaseComponent);

  var _super = _createSuper(ToggleBase);

  function ToggleBase() {
    var _this;

    _classCallCheck(this, ToggleBase);

    _this = _super.apply(this, arguments);
    _this.internalChecked = _this.defaultChecked || _this.checked;
    return _this;
  }

  _createClass(ToggleBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          internalChecked = this.internalChecked,
          disabled = this.disabled,
          label = this.label,
          onText = this.onText,
          offText = this.offText;
      return h("div", {
        "class": classNames.root
      }, [this.$scopedSlots.label ? this.$scopedSlots.label({
        checked: internalChecked,
        disabled: disabled,
        label: label
      }) : h(Label, {
        "class": classNames.label,
        "attrs": {
          "for": "Toggle".concat(this.uid)
        }
      }, [label]), h("div", {
        "class": classNames.container
      }, [h("button", {
        "attrs": {
          "id": "Toggle".concat(this.uid)
        },
        "ref": "toggleButton",
        "class": classNames.pill,
        "on": {
          "click": this.onClick
        }
      }, [h("div", {
        "class": classNames.thumb
      })]), (internalChecked && onText || !internalChecked && offText) && h(Label, {
        "class": classNames.text,
        "attrs": {
          "for": "Toggle".concat(this.uid)
        }
      }, [internalChecked ? onText : offText])])]);
    }
  }, {
    key: "focus",
    value: function focus() {
      this.$refs.toggleButton.focus();
    }
  }, {
    key: "onCheckedChanged",
    value: function onCheckedChanged(checked, prevVal) {
      this.$emit('input', checked);
    }
  }, {
    key: "onClick",
    value: function onClick() {
      if (this.disabled) return;
      this.internalChecked = !this.internalChecked;
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          disabled = this.disabled,
          internalChecked = this.internalChecked,
          inlineLabel = this.inlineLabel,
          onText = this.onText,
          offText = this.offText;
      return getClassNames(this.styles, {
        theme: theme,
        className: className,
        disabled: disabled,
        checked: internalChecked,
        inlineLabel: inlineLabel,
        onOffMissing: !onText && !offText
      });
    }
  }]);

  return ToggleBase;
}(BaseComponent);

__decorate([Model('input', {
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "checked", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], ToggleBase.prototype, "label", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "defaultChecked", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "inlineLabel", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], ToggleBase.prototype, "onText", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], ToggleBase.prototype, "offText", void 0);

__decorate([Watch('internalChecked'), __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean, Boolean]), __metadata("design:returntype", void 0)], ToggleBase.prototype, "onCheckedChanged", null);

ToggleBase = __decorate([Component], ToggleBase);

export { ToggleBase };
