import { Customizations } from '@uifabric-vue/utilities';
import './node_modules/core-js/modules/es.symbol.js';
import './node_modules/core-js/modules/es.array.filter.js';
import './node_modules/core-js/modules/es.array.for-each.js';
import './node_modules/core-js/modules/es.array.join.js';
import './node_modules/core-js/modules/es.function.name.js';
import './node_modules/core-js/modules/es.object.define-properties.js';
import './node_modules/core-js/modules/es.object.define-property.js';
import './node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import './node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import './node_modules/core-js/modules/es.object.keys.js';
import './node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import { concatStyleSetsWithProps } from '@uifabric/merge-styles';
import Vue from 'vue';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var DefaultFields = ['theme', 'styles'];
function styled(Component, baseStyles, getProps, customizable, pure) {
  customizable = customizable || {
    scope: '',
    fields: undefined
  };
  var _customizable = customizable,
      scope = _customizable.scope,
      _customizable$fields = _customizable.fields,
      fields = _customizable$fields === void 0 ? DefaultFields : _customizable$fields;

  var _styles;

  var styledComponent = Vue.extend({
    name: "Styled".concat(Component.displayName || Component.name),
    functional: true,
    render: function render(h, context) {
      var settings = Customizations.getSettings(fields, scope);

      var customizedStyles = settings.styles,
          dir = settings.dir,
          rest = _objectWithoutProperties(settings, ["styles", "dir"]);

      var additionalProps = getProps ? getProps(this) : undefined;

      if (!_styles || customizedStyles !== _styles.__cachedInputs__[1] || !!context.props.styles) {
        _styles = function _styles(styleProps) {
          return concatStyleSetsWithProps(styleProps, baseStyles, context.props.styles);
        };

        _styles.__cachedInputs__ = [baseStyles, context.props.styles];
      }

      return h(Component, _objectSpread(_objectSpread({}, context.data), {}, {
        "class": [context.props.className, context.data["class"]].filter(function (e) {
          return e;
        }).join(' '),
        props: _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, rest), additionalProps), context.props), {}, {
          className: [context.props.className, context.data["class"]].filter(function (e) {
            return e;
          }).join(' '),
          styles: _styles
        })
      }), context.children);
    }
  });
  return styledComponent;
}

export { styled };
