import { createTheme, loadTheme as loadTheme$1 } from '@uifabric/styling';
import { registerCSSVars } from './registerCSSVars.js';

function loadTheme(theme) {
  var useCSSVars = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  var _theme = createTheme(theme);

  if (useCSSVars) {
    var palette = _theme.palette,
        semanticColors = _theme.semanticColors;
    palette = registerCSSVars('palette', palette);
    semanticColors = registerCSSVars('semanticColors', semanticColors);
    loadTheme$1({
      palette: palette,
      semanticColors: semanticColors
    });
  }

  return _theme;
}

export { loadTheme };
