import './node_modules/core-js/modules/es.array.concat.js';
import './node_modules/core-js/modules/es.date.to-string.js';
import './node_modules/core-js/modules/es.object.to-string.js';
import './node_modules/core-js/modules/es.regexp.to-string.js';
import '@uifabric-vue/utilities';
import './node_modules/core-js/modules/es.symbol.js';
import './node_modules/core-js/modules/es.array.filter.js';
import './node_modules/core-js/modules/es.array.for-each.js';
import './node_modules/core-js/modules/es.array.join.js';
import './node_modules/core-js/modules/es.function.name.js';
import './node_modules/core-js/modules/es.object.define-properties.js';
import './node_modules/core-js/modules/es.object.define-property.js';
import './node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import './node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import './node_modules/core-js/modules/es.object.keys.js';
import './node_modules/core-js/modules/web.dom-collections.for-each.js';
import '@babel/runtime/helpers/defineProperty';
import './node_modules/core-js/modules/es.symbol.description.js';
import './node_modules/core-js/modules/es.symbol.iterator.js';
import './node_modules/core-js/modules/es.array.from.js';
import './node_modules/core-js/modules/es.array.is-array.js';
import './node_modules/core-js/modules/es.array.iterator.js';
import './node_modules/core-js/modules/es.array.map.js';
import './node_modules/core-js/modules/es.array.slice.js';
import './node_modules/core-js/modules/es.number.constructor.js';
import './node_modules/core-js/modules/es.string.iterator.js';
import './node_modules/core-js/modules/web.dom-collections.iterator.js';
import './node_modules/core-js/modules/es.array.reduce.js';
import '@babel/runtime/helpers/toConsumableArray';
import '../utilities/positioning/positioning.types.js';
import '../utilities/positioning/positioning.js';
import './node_modules/core-js/modules/es.regexp.exec.js';
import './node_modules/core-js/modules/es.string.split.js';
import '../utilities/grid/Grid.js';
import '../utilities/grid/GridCell.js';
import '../utilities/color/shades.js';
import './node_modules/core-js/modules/es.parse-int.js';
import './node_modules/core-js/modules/es.string.match.js';
import './node_modules/core-js/modules/es.string.trim.js';
import '../utilities/keytips/IKeytipTransitionKey.js';
import '../utilities/keytips/KeytipConstants.js';
import '../utilities/keytips/KeytipManager.js';
import { toKebabCase } from '../utilities/toKebabCase.js';
import '../utilities/responsiveMode.js';
import '../utilities/selectableOption/SelectableOption.types.js';
import * as index from '../components/index.js';
import { loadTheme } from './loadTheme.js';

function install(Vue) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var theme = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  for (var componentName in index) {
    var Component = index[componentName];

    if (Component && Component.prototype instanceof Vue) {
      var name = "".concat(options.prefix || 'f', "-").concat(toKebabCase(componentName));
      Vue.component(name, Component);
    }
  }

  loadTheme(theme, options.useCSSVars);
}

export default install;
