import './node_modules/core-js/modules/es.array.concat.js';
import { getDocument } from '@uifabric-vue/utilities';
import './node_modules/core-js/modules/es.array.join.js';

var STYLE_PREFIX = '__fabric__';
function registerCSSVars(key, obj) {
  var document = getDocument();
  if (!document) return obj;
  var id = "".concat(STYLE_PREFIX).concat(key);
  var style = document.getElementById(id);

  if (!style) {
    style = document.createElement('style');
    style.id = "".concat(STYLE_PREFIX).concat(key);
    document.head.appendChild(style);
  }

  var properties = {};
  var css = [];

  for (var _key in obj) {
    var value = obj[_key];
    properties[_key] = "var(--fabric-".concat(_key, ")");
    css.push("--fabric-".concat(_key, ": ").concat(value, ";"));
  }

  style.innerHTML = "\n  :root {\n    ".concat(css.join('\n'), "\n  }");
  return properties;
}

export { registerCSSVars };
