import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { BaseButton } from '../BaseButton';
import BaseComponent from '../../BaseComponent';
import { getStyles } from './ActionButton.styles';
let ActionButton = class ActionButton extends BaseComponent {
    get internalStyles() {
        const { theme, styles } = this;
        return getStyles(theme, styles);
    }
    render() {
        const props = {
            ...this.$props,
            variantClassName: 'ms-Button--action ms-Button--command',
            styles: this.internalStyles,
        };
        return (<BaseButton {...{
            props,
            attrs: this.$attrs,
            on: this.$listeners,
            scopedSlots: this.$scopedSlots,
        }}/>);
    }
};
__decorate([
    Prop({ type: String, default: '' }),
    __metadata("design:type", String)
], ActionButton.prototype, "href", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], ActionButton.prototype, "disabled", void 0);
__decorate([
    Prop({ type: Object, default: null }),
    __metadata("design:type", Object)
], ActionButton.prototype, "iconProps", void 0);
ActionButton = __decorate([
    Component
], ActionButton);
export { ActionButton };
//# sourceMappingURL=ActionButton.jsx.map