import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent';
import { BaseButton } from '../BaseButton';
import { getStyles } from './CommandBarButton.styles';
let CommandBarButton = class CommandBarButton extends BaseComponent {
    get internalStyles() {
        const { theme, styles } = this;
        return getStyles(theme, styles);
    }
    render() {
        const props = {
            variantClassName: 'ms-Button--commandBar',
            styles: this.internalStyles,
        };
        return (<BaseButton {...{ props, attrs: this.$attrs }}>
        {this.$slots.default}
      </BaseButton>);
    }
};
CommandBarButton = __decorate([
    Component
], CommandBarButton);
export { CommandBarButton };
//# sourceMappingURL=CommandBarButton.jsx.map