import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent';
import { getStyles } from './CompoundButton.styles';
import { BaseButton } from '../BaseButton';
let CompoundButton = class CompoundButton extends BaseComponent {
    get internalStyles() {
        const { primary = false, theme } = this;
        const styles = {};
        return getStyles(theme, styles, primary);
    }
    render() {
        const { primary, internalStyles } = this;
        const props = {
            variantClassName: primary ? 'ms-Button--compoundPrimary' : 'ms-Button--compound',
            styles: internalStyles,
        };
        return (<BaseButton {...{ props, attrs: this.$attrs }}>
        {this.$slots.default}
      </BaseButton>);
    }
};
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], CompoundButton.prototype, "primary", void 0);
CompoundButton = __decorate([
    Component
], CompoundButton);
export { CompoundButton };
//# sourceMappingURL=CompoundButton.jsx.map