import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { BaseButton } from '../BaseButton';
import { getStyles } from './DefaultButton.styles';
import BaseComponent from '../../BaseComponent';
let DefaultButton = class DefaultButton extends BaseComponent {
    get internalStyles() {
        const { primary = false, theme } = this;
        return getStyles(theme, this.styles, primary);
    }
    render() {
        const { primary, internalStyles } = this;
        const props = {
            ...this.$props,
            variantClassName: primary ? 'ms-Button--primary' : 'ms-Button--default',
            styles: internalStyles,
        };
        return (<BaseButton {...{ props, attrs: this.$attrs }}>
        {this.$slots.default}
      </BaseButton>);
    }
};
__decorate([
    Prop({ type: String, default: '' }),
    __metadata("design:type", String)
], DefaultButton.prototype, "text", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], DefaultButton.prototype, "primary", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], DefaultButton.prototype, "disabled", void 0);
DefaultButton = __decorate([
    Component
], DefaultButton);
export { DefaultButton };
//# sourceMappingURL=DefaultButton.jsx.map