// import { IButtonStyles } from '../Button.types'
import { getStyles as getBaseButtonStyles } from '../BaseButton.styles';
import { getStyles as getSplitButtonStyles } from '../SplitButton/SplitButton.styles';
import { primaryStyles, standardStyles } from '../ButtonThemes';
import { concatStyleSets } from '@uifabric/merge-styles';
import { memoizeFunction } from '@uifabric-vue/utilities';
import { FontWeights } from '@uifabric/styling';
const DEFAULT_BUTTON_HEIGHT = '32px';
const DEFAULT_BUTTON_MIN_WIDTH = '80px';
export const getStyles = memoizeFunction((theme, customStyles, primary) => {
    const baseButtonStyles = getBaseButtonStyles(theme);
    const splitButtonStyles = getSplitButtonStyles(theme);
    const defaultButtonStyles = {
        root: {
            minWidth: DEFAULT_BUTTON_MIN_WIDTH,
            height: DEFAULT_BUTTON_HEIGHT,
        },
        label: {
            fontWeight: FontWeights.semibold,
        },
    };
    return concatStyleSets(baseButtonStyles, defaultButtonStyles, primary ? primaryStyles(theme) : standardStyles(theme), splitButtonStyles, customStyles);
});
//# sourceMappingURL=DefaultButton.styles.js.map