import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { getStyles } from './IconButton.styles';
import { BaseButton } from '../BaseButton';
import BaseComponent from '../../BaseComponent';
let IconButton = class IconButton extends BaseComponent {
    get internalStyles() {
        const { theme, styles } = this;
        return getStyles(theme, styles);
    }
    render() {
        const { disabled, internalStyles } = this;
        const props = {
            disabled,
            variantClassName: 'ms-Button--icon',
            styles: internalStyles,
        };
        return (<BaseButton {...{ props, attrs: this.$attrs }}>
        {this.$slots.default}
      </BaseButton>);
    }
};
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], IconButton.prototype, "disabled", void 0);
IconButton = __decorate([
    Component({
        components: { BaseButton },
        inheritAttrs: false,
    })
], IconButton);
export { IconButton };
//# sourceMappingURL=IconButton.jsx.map