import { getStyles as getBaseButtonStyles } from '../BaseButton.styles';
import { memoizeFunction } from '@uifabric-vue/utilities';
import { getFocusStyle } from '@uifabric/styling';
import { concatStyleSets } from '@uifabric/merge-styles';
export const getStyles = memoizeFunction((theme, customStyles, focusInset, focusColor) => {
    const baseButtonStyles = getBaseButtonStyles(theme);
    const messageBarButtonStyles = {
        root: [
            getFocusStyle(theme, {
                inset: 1,
                highContrastStyle: {
                    outlineOffset: '-4px',
                    outlineColor: 'ActiveBorder',
                },
                borderColor: 'transparent',
            }),
            {
                height: 24,
                borderColor: theme.palette.neutralTertiaryAlt,
            },
        ],
    };
    return concatStyleSets(baseButtonStyles, messageBarButtonStyles, customStyles);
});
//# sourceMappingURL=MessageBarButton.styles.js.map