import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { Layer } from '../Layer/';
import { CalloutContent } from './CalloutContent';
import StatelessComponent from '../StatelessComponent';
import { DirectionalHint } from '../../common/DirectionalHint';
let Callout = class Callout extends StatelessComponent {
    render(h, context) {
        if (!(context.props.target instanceof Node))
            return;
        const { layerProps, ...rest } = context.props;
        const content = h(CalloutContent, {
            ...context.data,
            props: {
                ...rest,
                ...context.data.attrs,
            },
        }, context.children);
        return context.props.doNotLayer ? content : h(Layer, {
            ...context.data,
            props: {
                ...layerProps,
            },
        }, [content]);
    }
};
__decorate([
    Prop({ type: HTMLElement, required: true }),
    __metadata("design:type", Object)
], Callout.prototype, "target", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], Callout.prototype, "doNotLayer", void 0);
__decorate([
    Prop({ type: Number, default: DirectionalHint.bottomAutoEdge }),
    __metadata("design:type", Boolean)
], Callout.prototype, "directionalHint", void 0);
Callout = __decorate([
    Component
], Callout);
export { Callout };
//# sourceMappingURL=Callout.jsx.map