import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import StatelessComponent from '../StatelessComponent';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { FontIcon, Icon } from '../Icon';
const getClassNames = classNamesFunction();
let CheckBase = class CheckBase extends StatelessComponent {
    render(h, ctx) {
        const { checked, className, theme, styles, useFastIcons } = ctx.props;
        const classNames = getClassNames(styles, { theme: theme, className, checked });
        const IconComponent = useFastIcons ? FontIcon : Icon;
        return (<div class={classNames.root}>
        <IconComponent icon-name="CircleRing" class={classNames.circle}/>
        <IconComponent icon-name="StatusCircleCheckmark" class={classNames.check}/>
      </div>);
    }
};
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], CheckBase.prototype, "checked", void 0);
__decorate([
    Prop({ type: Boolean, default: true }),
    __metadata("design:type", Boolean)
], CheckBase.prototype, "useFastIcons", void 0);
CheckBase = __decorate([
    Component
], CheckBase);
export { CheckBase };
//# sourceMappingURL=Check.base.jsx.map