import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { ChoiceGroupOption } from './ChoiceGroupOption';
import BaseComponent from '../BaseComponent';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { Label } from '../Label';
const getClassNames = classNamesFunction();
let ChoiceGroupBase = class ChoiceGroupBase extends BaseComponent {
    constructor() {
        super(...arguments);
        this.selectedOption = {};
    }
    get classNames() {
        const { styles, theme, className } = this;
        return getClassNames(styles, {
            theme, className, optionsContainIconOrImage: false,
        });
    }
    onClick(ev, option) {
        ev.preventDefault();
        if (option.disabled)
            return;
        this.selectedOption = option;
    }
    render() {
        const { classNames, label, required, disabled, selectedOption, options } = this;
        return (<div class={classNames.applicationRole}>
        <div class={classNames.root}>
          {label && (<Label class={classNames.label} required={required} disabled={disabled}>
              {label}
            </Label>)}

          <div class={classNames.flexContainer}>
            {options.map(option => {
            return (<ChoiceGroupOption id={option.key} key={option.key} {...{ props: option }} checked={selectedOption.key === option.key} nativeOnClick={ev => this.onClick(ev, option)}>
                  {option.text}
                </ChoiceGroupOption>);
        })}
          </div>
        </div>
      </div>);
    }
};
__decorate([
    Prop({ type: String, default: null }),
    __metadata("design:type", String)
], ChoiceGroupBase.prototype, "label", void 0);
__decorate([
    Prop({ type: Array, default: () => [] }),
    __metadata("design:type", Array)
], ChoiceGroupBase.prototype, "options", void 0);
__decorate([
    Prop({ type: Array, default: () => [] }),
    __metadata("design:type", Array)
], ChoiceGroupBase.prototype, "value", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], ChoiceGroupBase.prototype, "disabled", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], ChoiceGroupBase.prototype, "required", void 0);
ChoiceGroupBase = __decorate([
    Component({
        components: { ChoiceGroupOption, Label },
    })
], ChoiceGroupBase);
export { ChoiceGroupBase };
//# sourceMappingURL=ChoiceGroup.base.jsx.map