import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import Vue from 'vue';
let DelayedRender = class DelayedRender extends Vue {
    constructor() {
        super(...arguments);
        this.isRendered = false;
    }
    mounted() {
        this.timeoutId = setTimeout(() => {
            this.isRendered = true;
        }, this.delay);
    }
    beforeDestroy() {
        if (this.timeoutId)
            clearTimeout(this.timeoutId);
    }
    render() {
        return this.isRendered ? (<div>{this.$slots.default}</div>) : null;
    }
};
__decorate([
    Prop({ type: Number, default: 0 }),
    __metadata("design:type", Number)
], DelayedRender.prototype, "delay", void 0);
DelayedRender = __decorate([
    Component
], DelayedRender);
export { DelayedRender };
//# sourceMappingURL=DelayedRender.jsx.map