import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent';
import { DetailsColumn } from '../DetailsColumn';
import { classNamesFunction } from '@uifabric-vue/utilities';
const getClassNames = classNamesFunction();
let DetailsHeaderBase = class DetailsHeaderBase extends BaseComponent {
    get classNames() {
        const { styles, theme, className, } = this;
        return getClassNames(styles, {
            theme: theme,
            isAllSelected: false,
            isSelectAllHidden: false,
            isResizingColumn: false,
            isSizing: false,
            isAllCollapsed: false,
            isCheckboxHidden: false,
            className,
        });
    }
    render() {
        const { classNames, columns } = this;
        return (<div class={classNames.root} role="row">
        {columns.map((column, index) => (<DetailsColumn key={column.key} column={column} columnIndex={index} parentId={this.uid}/>))}
      </div>);
    }
};
__decorate([
    Prop({ type: Array, required: true }),
    __metadata("design:type", Array)
], DetailsHeaderBase.prototype, "columns", void 0);
DetailsHeaderBase = __decorate([
    Component({
        components: { DetailsColumn },
    })
], DetailsHeaderBase);
export { DetailsHeaderBase };
//# sourceMappingURL=DetailsHeader.base.jsx.map