import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { DetailsRowFields } from './DetailsRowFields';
const getClassNames = classNamesFunction();
const NO_COLUMNS = [];
let DetailsRowBase = class DetailsRowBase extends BaseComponent {
    constructor() {
        super(...arguments);
        this.showCheckbox = false;
    }
    get classNames() {
        const { styles, theme, className, compact, } = this;
        return {
            // ...this._classNames,
            ...getClassNames(styles, {
                theme: theme,
                isSelected: false,
                canSelect: false,
                anySelected: false,
                checkboxCellClassName: '',
                droppingClassName: '',
                className,
                compact,
                enableUpdateAnimations: false,
            }),
        };
    }
    get rowClassNames() {
        return {
            isMultiline: this.classNames.isMultiline,
            isRowHeader: this.classNames.isRowHeader,
            cell: this.classNames.cell,
            cellAnimation: this.classNames.cellAnimation,
            cellPadded: this.classNames.cellPadded,
            cellUnpadded: this.classNames.cellUnpadded,
            fields: this.classNames.fields,
        };
    }
    /**
     * measure cell at index. and call the call back with the measured cell width when finish measure
     *
     * @param index - The cell index
     * @param onMeasureDone - The call back function when finish measure
     */
    measureCell(index, onMeasureDone) {
        const { columns = NO_COLUMNS } = this;
        const column = { ...columns[index] };
        column.minWidth = 0;
        column.maxWidth = 999999;
        delete column.calculatedWidth;
        // this.setState({
        //   columnMeasureInfo: {
        //     index,
        //     column,
        //     onMeasureDone,
        //   },
        // })
    }
    render() {
        const { classNames, rowClassNames, item, columns, showCheckbox } = this;
        return (<div class={classNames.root}>
        <DetailsRowFields row-class-names={rowClassNames} 
        // cells-by-column={{cellsByColumn}}
        columns={columns} item={item} item-index={0} column-start-index={showCheckbox ? 1 : 0} {...{
            scopedSlots: this.$scopedSlots,
        }}/>
      </div>);
    }
};
__decorate([
    Prop({ type: Array, required: true }),
    __metadata("design:type", Array)
], DetailsRowBase.prototype, "columns", void 0);
__decorate([
    Prop({ type: Object, required: true }),
    __metadata("design:type", Object)
], DetailsRowBase.prototype, "item", void 0);
__decorate([
    Prop({ type: Boolean, required: true }),
    __metadata("design:type", Boolean)
], DetailsRowBase.prototype, "compact", void 0);
DetailsRowBase = __decorate([
    Component
], DetailsRowBase);
export { DetailsRowBase };
//# sourceMappingURL=DetailsRow.base.jsx.map