import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { getStyles } from './FacepileButton.styles';
import BaseComponent from '../../BaseComponent';
import { BaseButton } from '../../Button/';
let FacepileButton = class FacepileButton extends BaseComponent {
    get internalStyles() {
        return getStyles(this.theme, this.className, this.styles);
    }
    render() {
        const props = {
            ...this.$props,
            variantClassName: 'ms-Button--facepile',
            styles: this.internalStyles,
        };
        return (<BaseButton {...{
            props,
            attrs: this.$attrs,
            on: this.$listeners,
            scopedSlots: this.$scopedSlots,
        }}>
        {this.$slots.flex}
      </BaseButton>);
    }
};
FacepileButton = __decorate([
    Component
], FacepileButton);
export { FacepileButton };
//# sourceMappingURL=FacepileButton.jsx.map