import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent';
const getClassNames = classNamesFunction({
    disableCaching: true,
});
let LabelBase = class LabelBase extends StatelessComponent {
    render(h, context) {
        const { theme, className, disabled, required } = context.props;
        const classNames = getClassNames(context.props.styles, {
            className,
            disabled,
            required,
            theme: theme,
        });
        return (<label class={classNames.root} {...context.data}>
        {context.children}
      </label>);
    }
};
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], LabelBase.prototype, "disabled", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], LabelBase.prototype, "required", void 0);
LabelBase = __decorate([
    Component
], LabelBase);
export { LabelBase };
//# sourceMappingURL=Label.base.jsx.map