import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent';
const getClassNames = classNamesFunction();
let LinkBase = class LinkBase extends StatelessComponent {
    render(h, context) {
        const { theme, className, styles, href, disabled } = context.props;
        const classNames = getClassNames(styles, {
            theme: theme,
            className,
            isButton: !href,
            isDisabled: disabled,
        });
        const component = href ? 'a' : 'button';
        return h(component, {
            ...context.data,
            class: classNames.root,
            attrs: {
                ...context.data.attrs,
                ...href && { href },
                ...!href && { type: 'button' },
            },
        }, context.children);
    }
};
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], LinkBase.prototype, "disabled", void 0);
__decorate([
    Prop({ type: String, default: '' }),
    __metadata("design:type", String)
], LinkBase.prototype, "href", void 0);
LinkBase = __decorate([
    Component
], LinkBase);
export { LinkBase };
//# sourceMappingURL=Link.base.jsx.map