import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../BaseComponent';
import { classNamesFunction } from '@uifabric-vue/utilities';
const getClassNames = classNamesFunction();
let OverlayBase = class OverlayBase extends BaseComponent {
    get classNames() {
        const { theme, className, dark: isDark } = this;
        return getClassNames(this.styles, {
            theme,
            className,
            isDark,
        });
    }
    render() {
        const { classNames } = this;
        return (<div class={classNames.root}>
        {this.$slots.default}
      </div>);
    }
};
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], OverlayBase.prototype, "dark", void 0);
OverlayBase = __decorate([
    Component
], OverlayBase);
export { OverlayBase };
//# sourceMappingURL=Overlay.base.jsx.map