import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent';
const getClassNames = classNamesFunction();
let SeparatorBase = class SeparatorBase extends StatelessComponent {
    render(h, context) {
        const { styles, theme, className, vertical, alignContent } = context.props;
        const classNames = getClassNames(styles, {
            theme,
            className,
            alignContent,
            vertical,
        });
        return (<div class={classNames.root}>
        <div class={classNames.content} role="separator" aria-orientation={vertical ? 'vertical' : 'horizontal'}>
          {context.children}
        </div>
      </div>);
    }
};
__decorate([
    Prop({ type: String, default: 'center' }),
    __metadata("design:type", String)
], SeparatorBase.prototype, "alignContent", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], SeparatorBase.prototype, "vertical", void 0);
SeparatorBase = __decorate([
    Component
], SeparatorBase);
export { SeparatorBase };
//# sourceMappingURL=Separator.base.jsx.map