import { __decorate, __metadata } from "tslib";
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../../StatelessComponent';
import { Component, Prop } from 'vue-property-decorator';
const getClassNames = classNamesFunction();
let ShimmerLineBase = class ShimmerLineBase extends StatelessComponent {
    render(h, ctx) {
        const { height, styles, width = '100%', borderStyle, theme } = ctx.props;
        const classNames = getClassNames(styles, {
            theme: theme,
            height,
            borderStyle,
        });
        return (<div style={{ width: width, minWidth: typeof width === 'number' ? `${width}px` : 'auto' }} class={classNames.root}>
        <svg width="2" height="2" class={classNames.topLeftCorner}>
          <path d="M0 2 A 2 2, 0, 0, 1, 2 0 L 0 0 Z"/>
        </svg>
        <svg width="2" height="2" class={classNames.topRightCorner}>
          <path d="M0 0 A 2 2, 0, 0, 1, 2 2 L 2 0 Z"/>
        </svg>
        <svg width="2" height="2" class={classNames.bottomRightCorner}>
          <path d="M2 0 A 2 2, 0, 0, 1, 0 2 L 2 2 Z"/>
        </svg>
        <svg width="2" height="2" class={classNames.bottomLeftCorner}>
          <path d="M2 2 A 2 2, 0, 0, 1, 0 0 L 0 2 Z"/>
        </svg>
      </div>);
    }
};
__decorate([
    Prop({ type: Number, default: 0 }),
    __metadata("design:type", Number)
], ShimmerLineBase.prototype, "height", void 0);
ShimmerLineBase = __decorate([
    Component
], ShimmerLineBase);
export default ShimmerLineBase;
//# sourceMappingURL=ShimmerLine.base.jsx.map