import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent';
import { DelayedRender } from '../DelayedRender';
const getClassNames = classNamesFunction();
let Spinner = class Spinner extends StatelessComponent {
    render(h, context) {
        const { theme, styles, className, ariaLabel, ariaLive, size, label, labelPosition } = context.props;
        const statusMessage = ariaLabel;
        const classNames = getClassNames(styles, {
            theme,
            size,
            className,
            labelPosition,
        });
        return (<div class={classNames.root}>
        <div class={classNames.circle}/>
        {(context.scopedSlots.default || label) && (<div class={classNames.label}>
            {context.scopedSlots.default
            ? context.scopedSlots.default({})
            : label}
          </div>)}

        {statusMessage && (<div role="status" aria-live={ariaLive}>
            <DelayedRender>
              <div class={classNames.screenReaderText}>{statusMessage}</div>
            </DelayedRender>
          </div>)}
      </div>);
    }
};
__decorate([
    Prop({ type: String, default: null }),
    __metadata("design:type", String)
], Spinner.prototype, "label", void 0);
__decorate([
    Prop({ type: String, default: null }),
    __metadata("design:type", String)
], Spinner.prototype, "ariaLabel", void 0);
__decorate([
    Prop({ type: String, default: 'polite', validator: v => ['assertive', 'polite', 'off'].indexOf(v) > -1 }),
    __metadata("design:type", String)
], Spinner.prototype, "ariaLive", void 0);
__decorate([
    Prop({ type: String, default: 'bottom' }),
    __metadata("design:type", String)
], Spinner.prototype, "labelPosition", void 0);
__decorate([
    Prop({ type: Number, default: 20 }),
    __metadata("design:type", Number)
], Spinner.prototype, "size", void 0);
Spinner = __decorate([
    Component
], Spinner);
export default Spinner;
//# sourceMappingURL=Spinner.base.jsx.map