import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { styles } from './Stack.styles';
import StatelessComponent from '../StatelessComponent';
import { mergeStyleSets } from '@uifabric/styling';
const getClassNames = classNamesFunction();
let Stack = class Stack extends StatelessComponent {
    render(h, ctx) {
        const { theme, tokens, verticalFill, horizontal, reversed, grow, wrap, horizontalAlign, verticalAlign, disableShrink, className } = ctx.props;
        const classNames = getClassNames(mergeStyleSets(styles({
            className,
            verticalFill,
            horizontal,
            reversed,
            grow,
            wrap,
            horizontalAlign,
            verticalAlign,
            disableShrink,
        }, theme, tokens), ctx.props.styles));
        return h('div', {
            ...ctx.data,
            class: classNames.root,
        }, ctx.children);
    }
};
__decorate([
    Prop({ type: String, default: '' }),
    __metadata("design:type", String)
], Stack.prototype, "verticalFill", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], Stack.prototype, "horizontal", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], Stack.prototype, "reversed", void 0);
__decorate([
    Prop({ type: Number, default: 0 }),
    __metadata("design:type", Number)
], Stack.prototype, "childrenGap", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], Stack.prototype, "grow", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], Stack.prototype, "wrap", void 0);
__decorate([
    Prop({ type: String, default: '' }),
    __metadata("design:type", String)
], Stack.prototype, "horizontalAlign", void 0);
__decorate([
    Prop({ type: String, default: '' }),
    __metadata("design:type", String)
], Stack.prototype, "verticalAlign", void 0);
__decorate([
    Prop({ type: Boolean, default: false }),
    __metadata("design:type", Boolean)
], Stack.prototype, "disableShrink", void 0);
__decorate([
    Prop({ type: Object, default: () => { } }),
    __metadata("design:type", Object)
], Stack.prototype, "tokens", void 0);
Stack = __decorate([
    Component({
        components: {},
    })
], Stack);
export { Stack };
//# sourceMappingURL=Stack.jsx.map