import { getGlobalClassNames } from '@uifabric/styling';
const GlobalClassNames = {
    root: 'ms-StackItem',
};
const alignMap = {
    start: 'flex-start',
    end: 'flex-end',
};
export const StackItemStyles = (props, theme, tokens) => {
    const { grow, shrink, disableShrink, align, verticalFill, order, className } = props;
    const classNames = getGlobalClassNames(GlobalClassNames, theme);
    return {
        root: [
            theme.fonts.medium,
            classNames.root,
            {
                margin: tokens.margin,
                height: verticalFill ? '100%' : 'auto',
                width: 'auto',
            },
            grow && { flexGrow: grow === true ? 1 : grow },
            (disableShrink || (!grow && !shrink)) && {
                flexShrink: 0,
            },
            shrink &&
                !disableShrink && {
                flexShrink: 1,
            },
            align && {
                alignSelf: alignMap[align] || align,
            },
            order && {
                order: order,
            },
            className,
        ],
    };
};
//# sourceMappingURL=StackItem.styles.js.map