import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../BaseComponent';
import { Grid } from '../../utilities/grid/';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { ColorPickerGridCell } from './ColorPickerGridCell/';
const getClassNames = classNamesFunction();
let SwatchColorPickerBase = class SwatchColorPickerBase extends BaseComponent {
    get classNames() {
        const { theme, styles, className, cellMargin } = this;
        return getClassNames(styles, {
            theme,
            className,
            cellMargin,
        });
    }
    render() {
        const { colorCells, columnCount, cellShape, cellWidth, cellHeight } = this;
        return (<Grid items={colorCells} column-count={columnCount} {...{
            scopedSlots: {
                default: ({ cell: item }) => (<ColorPickerGridCell color={item.color} circle={cellShape === 'circle'} width={cellWidth} height={cellHeight}/>),
            },
        }}>
      </Grid>);
    }
};
__decorate([
    Prop({ default: 10 }),
    __metadata("design:type", Number)
], SwatchColorPickerBase.prototype, "cellMargin", void 0);
__decorate([
    Prop({ type: Array, default: () => [] }),
    __metadata("design:type", Array)
], SwatchColorPickerBase.prototype, "colorCells", void 0);
__decorate([
    Prop({ type: Number }),
    __metadata("design:type", Number)
], SwatchColorPickerBase.prototype, "columnCount", void 0);
__decorate([
    Prop({ type: String, default: 'circle' }),
    __metadata("design:type", String)
], SwatchColorPickerBase.prototype, "cellShape", void 0);
__decorate([
    Prop({ type: Number }),
    __metadata("design:type", Number)
], SwatchColorPickerBase.prototype, "cellHeight", void 0);
__decorate([
    Prop({ type: Number }),
    __metadata("design:type", Number)
], SwatchColorPickerBase.prototype, "cellWidth", void 0);
SwatchColorPickerBase = __decorate([
    Component({
        components: { Grid, ColorPickerGridCell },
        inheritAttrs: false,
    })
], SwatchColorPickerBase);
export { SwatchColorPickerBase };
//# sourceMappingURL=SwatchColorPicker.base.jsx.map