import { createTheme, loadTheme as baseLoadTheme } from '@uifabric/styling';
import { registerCSSVars } from './registerCSSVars';
export function loadTheme(theme, useCSSVars = false) {
    const _theme = createTheme(theme);
    if (useCSSVars) {
        let { palette, semanticColors } = _theme;
        // generate new css vars
        palette = registerCSSVars('palette', palette);
        semanticColors = registerCSSVars('semanticColors', semanticColors);
        // update theme
        baseLoadTheme({
            palette,
            semanticColors,
        });
    }
    return _theme;
}
//# sourceMappingURL=loadTheme.js.map