import * as Components from '../components';
import { toKebabCase } from '../utilities';
import { loadTheme } from './loadTheme';
export default function install(Vue, options = {}, theme = {}) {
    for (const componentName in Components) {
        const Component = Components[componentName];
        if (Component && Component.prototype instanceof Vue) {
            const name = `${options.prefix || 'f'}-${toKebabCase(componentName)}`;
            Vue.component(name, Component);
        }
    }
    loadTheme(theme, options.useCSSVars);
}
/*

============================
    CSS Vars
--neutralLight: #eaeaea;
--bodyFrameBackground: var(--neutralLight)

{
  neutralLight: 'var(--neutralLight)'
}
{
  bodyFrameBackground: 'var(--neutralLight)'
}

======================================
    No CSS Vars
{
  neutralLight: '#eaeaea'
}
{
  bodyFrameBackground: '#eaeaea'
}

 */
//# sourceMappingURL=office-fabric.js.map