import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { classNamesFunction, toMatrix } from '@uifabric-vue/utilities';
import BaseComponent from '../../components/BaseComponent';
const getClassNames = classNamesFunction();
let GridBase = class GridBase extends BaseComponent {
    get rowsOfItems() {
        const { items, columnCount } = this;
        return toMatrix(items, columnCount);
    }
    get classNames() {
        const { theme, styles } = this;
        return getClassNames(styles, { theme });
    }
    render() {
        const { classNames, rowsOfItems } = this;
        return (<table class={classNames.root}>
        <tbody>
          {rowsOfItems.map((rows, rowIndex) => (<tr key={`${this.uid}-${rowIndex}-row`} role="row">
              {rows.map((cell, cellIndex) => (<td key={`${this.uid}-${rowIndex}-${cellIndex}-cell`} class={classNames.tableCell}>
                  {this.$scopedSlots.default ? this.$scopedSlots.default({ cell, index: cellIndex }) : null}
                </td>))}
            </tr>))}
        </tbody>
      </table>);
    }
};
__decorate([
    Prop(),
    __metadata("design:type", Array)
], GridBase.prototype, "items", void 0);
__decorate([
    Prop(),
    __metadata("design:type", Number)
], GridBase.prototype, "columnCount", void 0);
GridBase = __decorate([
    Component({
        components: {},
        inheritAttrs: false,
    })
], GridBase);
export { GridBase };
//# sourceMappingURL=Grid.base.jsx.map