import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../../components/BaseComponent';
import { ActionButton } from '../../components/Button/';
import { css } from '@uifabric-vue/utilities';
let GridCell = class GridCell extends BaseComponent {
    render() {
        const { className, item, cellDisabledStyle, cellIsSelectedStyle, selected, disabled } = this;
        return (<ActionButton class={css(className, {
            ['' + cellIsSelectedStyle]: selected,
            ['' + cellDisabledStyle]: disabled,
        })} getClassNames={this.getClassNames} {...{
            scopedSlots: {
                flex: this.$scopedSlots.default,
            },
        }}/>);
    }
};
__decorate([
    Prop({ type: Object, default: () => { } }),
    __metadata("design:type", Object)
], GridCell.prototype, "item", void 0);
__decorate([
    Prop({ type: Boolean }),
    __metadata("design:type", Boolean)
], GridCell.prototype, "disabled", void 0);
__decorate([
    Prop({ type: Boolean }),
    __metadata("design:type", Boolean)
], GridCell.prototype, "selected", void 0);
__decorate([
    Prop({ type: String }),
    __metadata("design:type", String)
], GridCell.prototype, "cellDisabledStyle", void 0);
__decorate([
    Prop({ type: String }),
    __metadata("design:type", String)
], GridCell.prototype, "cellIsSelectedStyle", void 0);
__decorate([
    Prop(),
    __metadata("design:type", Object)
], GridCell.prototype, "getClassNames", void 0);
GridCell = __decorate([
    Component({
        components: { ActionButton },
    })
], GridCell);
export { GridCell };
//# sourceMappingURL=GridCell.jsx.map